//
// Page scope
//
let entityMap = {
	'&': '&amp;',
	'<': '&lt;',
	'>': '&gt;',
	'"': '&quot;',
	"'": '&#39;',
	'/': '&#x2F;',
	'`': '&#x60;',
	'=': '&#x3D;'
};

//remove this array when old statuses are no longer needed
const OldStatuses = [
	'canHandle',
	'blocked',
	'bug',
	'deleted',
	'deleted',
	'drop',
	'dropExitGroup',
	'dropped',
	'exception',
	'filtered',
	'forward',
	'forwarded',
	'folderClosed',
	'hold',
	'ignore',
	'ignored',
	'processed',
	'reject',
	'rejected',
	'reprocessed',
	'removed',
	'running'
];

function reprocessJemhAuditEvent(event, id) {
	event.preventDefault();
	var projectKey=AJS.$('[name=projectKey]').attr('content');

	var jqXHR=AJS.$.ajax({
		type:"POST",
		url:AJS.params.baseURL+"/rest/jemh/latest/project/auditing/auditevent/reprocessing/reanimate?projectKey="+projectKey+"&id="+id+"&atl_token="+AJS.$('#jemh-ajs-atl-token').val(), timeout:5000});

	jqXHR.done(function(data, textStatus, errorMessage) {
		AJS.messages.success("#jemh-proj-auditing-messages", {
			title: "Re-animation complete!",
			body: "Please reload or navigate to <A HREF='"+AJS.params.baseURL+"/secure/jemh/project/JEMHAuditingProjectTab.jspa?projectKey="+projectKey+"'>Auditing page</A> to see updates"
		});

		//alert("Re-animation complete, please reload or navigate to Auditing page to see updates");
	}).fail(function(data, textStatus, errorMessage) {
		AJS.messages.error("#jemh-proj-auditing-messages", {
			title: "Re-animation failed",
			body: "errorMessage: "+errorMessage
		});
		//alert("Re-animation failed: "+textStatus);
	});
}

function createJemhTestCase(url) {
	console.log('create test case : '+url);

	// post
	//contentType: sent to the server as a header
	//dataType is the response
	var jqXHR=AJS.$.ajax({
		type:"PUT",
		url:url,
		timeout:30000}).done(function(data, textStatus, errorMessage) {
		if(data.errors) {
			console.error('createJemhTestCase() errors');
			AJS.messages.warning("#jemh-messages", {
				title:"Test Case Creation Failed",
				body: '<p>'+AJS.escapeHtml(data.errors)+'</p>',
				closeable: true
			});
		} else {
			AJS.messages.success("#jemh-messages", {
				title:"Test Case Created",
				body: '<p>Test Case id: '+data+' was created</p>',
				closeable: true,
				fadeout: 2000
			});
		}
	});
}

function popupEmailDetail(event, id) {
	event.preventDefault();
	var projectKey=AJS.$('[name=projectKey]').attr('content');
	var detailUrl=AJS.params.baseURL+'/rest/jemh/latest/project/auditing/auditevent/detail/'+projectKey+'?id='+id+'&atl_token='+AJS.$('#jemh-ajs-atl-token').val();
	var jqXHR=AJS.$.getJSON(detailUrl, {
		format: "json"
	});

	//http://dev-jira:8080/rest/jemh/latest/auditing/auditevent/detail/883
	jqXHR.done(function(data, textStatus, errorMessage) {
		if(data.errors) {
			console.error('popupEmailDetail() errors');
		}
		else {
			var dialog = new AJS.Dialog({
				width: 800,
				height: 600,
				id: "jemh-audit-detail-popup-dialog",
				closeOnOutsideClick: true
			});

			// PAGE 0 (first page)
			// adds header for first page
			dialog.addHeader("Email Detail");

			if (data.toArr) {
				var toContent='<UL>';
				for (var i=0 ; i<data.toArr.length ; i++)
				{
					toContent=toContent+'<LI>'+AJS.escapeHtml(data.toArr[i])+'</LI>';
				}
				toContent=toContent+'</UL>';
				dialog.addPanel("To:", "<UL class='aui'>"+toContent+"</UL>", "panel-body");
			}

			if (data.ccArr) {
				var ccContent='<UL>';
				for (var i=0 ; i<data.ccArr.length ; i++)
				{
					ccContent=ccContent+'<LI>'+AJS.escapeHtml(data.ccArr[i])+'</LI>';
				}
				ccContent=ccContent+'</UL>';
				dialog.addPanel("Cc:", "<UL class='aui'>"+ccContent+"</UL>", "panel-body");
			}

			var headerContent='<table class="aui"><tr><th>Header</th><th>Value</th></tr>';
			for (var i = 0, keys = Object.keys(data.headers), ii = keys.length; i < ii; i++) {
				headerContent=headerContent+'<tr><th>'+AJS.escapeHtml(keys[i])+'</th><td>'+AJS.escapeHtml(data.headers[keys[i]])+'</td></tr>';
			}
			headerContent=headerContent+'</table>';
			dialog.addPanel("Headers", headerContent, "panel-body");

			dialog.addPanel("Content", '<pre>'+data.content+'</pre>', "panel-body");

			// adds "Cancel" button to page 1
			dialog.addButton("Close", function (dialog) {
				dialog.hide();
			});

			dialog.gotoPage(0);
			dialog.gotoPanel(0);
			dialog.show();
		}
	}).fail(function(data, textStatus, errorMessage) {
		console.error("popupEmailDetail() failed: "+textStatus+" : "+detailUrl);
	});
}

//Project Auditing 'Report'
function popupReportDetail(event, id) {
	event.preventDefault();
	var projectKey=AJS.$('[name=projectKey]').attr('content');
	const jemhReportUrl=AJS.contextPath() + "/rest/jemh/latest/project/auditing/auditevent/report/"+projectKey+"/"+id;
	let jqXHR=AJS.$.getJSON(jemhReportUrl, {
		format: "json"
	});

	jqXHR.done(function(data, textStatus, errorMessage) {
		if(data.errors) {
			console.error('popupReportDetail() errors');
		}
		else {
			let dialog = new AJS.Dialog({
				width: 1000,
				height: 800,
				id: "jemh-audit-report-popup-dialog",
				closeOnOutsideClick: true
			});

			// adds header for first page
			dialog.addHeader("Report");
			dialog.addPanel("Report", "<div id='jemh-audit-report-section-popup' class='jemh-audit-report-section-popup'></div>", "panel-body");
			buildReportPage(data);

			// adds "Cancel" button to page 1
			dialog.addButton("Close", function (dialog) {
				dialog.hide();
			});

			dialog.gotoPage(0);
			dialog.gotoPanel(0);
			dialog.show();
		}
	}).fail(function(data, textStatus, errorMessage) {
		if(data.status === 401) {
			AJS.flag({
				type: 'error',
				title: 'Error running Test Case',
				body: "<p>Request failed with status code 401</p>",
				close: 'auto'
			});
		} else {
			console.error("popupReportDetail() failed: "+textStatus+" : "+jemhReportUrl);
		}
	});
}

function buildReportPage(json) {
	for(let i = 0; i < json.sections.length; i++) {
		let sectionHtml='<div class="jemh-audit-section"><h2 class="jemh-audit-section-heading">'+json.sections[i]+'</h2>';
		sectionHtml+='<ul class="jemh-audit-section-list">'
		for(let j = 0; j < json.messages[json.sections[i]].length; j++) {
			sectionHtml+='<li class="jemh-audit-report-section">'+addEntry(json.messages[json.sections[i]][j])+'</li>';
		}
		sectionHtml+="</ul></div><br/>";
		AJS.$('.jemh-audit-report-section-popup').append(sectionHtml);
	}
}

function addEntry(entry) {
	let entryHtml;
	if (entry.message!=null && entry.exceptionType==null)
	{
		if (entry.format)
		{
			if (entry.format==="pre")
			{
				entryHtml=entry.title+"<pre style='display: block; padding: 5px; border:1px solid black; background-color: #F0F7FF; font-family: monospace; white-space: pre-wrap; margin: 1em 0; word-wrap: break-word;'>"+encodeText(entry.message)+"</pre>";
			}
			else if (entry.format==="code")
			{
				entryHtml=entry.title+"<code style='display: block; padding: 5px; border:1px solid black; background-color: #F0F7FF; font-family: monospace; white-space: pre-wrap; margin: 1em 0; word-wrap: break-word;'>"+encodeText(entry.message)+"</code>";
			}
			else
			{
				entryHtml=entry.title+"<pre style='display: block; padding: 5px; border:1px solid black; background-color: #F0F7FF; font-family: monospace; white-space: pre-wrap; margin: 1em 0; word-wrap: break-word;'>Unknown format ("+entry.format+") "+encodeText(entry.message)+"</pre>";
			}
		}
		else
		{
			entryHtml=encodeText(entry.message);
		}
	}
	else
	{
		entryHtml='<table class="jemh-audit-exception-entry">';
		if (entry.message) {
			entryHtml+='<tr><th>Message</th><td>'+encodeText(entry.message)+'<td></tr>';
		}
		if (entry.valueSupplied) {
			entryHtml+='<tr><th>Value Supplied</th><td><pre>'+encodeText(entry.valueSupplied)+'</pre><td></tr>';
		}
		if (entry.validValues) {
			entryHtml+='<tr><th>Valid Values</th><td><pre>'+encodeText(entry.validValues)+'</pre><td></tr>';
		}
		if (entry.exceptionType) {
			entryHtml+='<tr><th>Exception Type</th><td>'+encodeText(entry.exceptionType)+'<td></tr>';
		}
		if (entry.exceptionMessage) {
			entryHtml+='<tr><th>Exception Msg</th><td>'+encodeText(entry.exceptionMessage)+'<td></tr>';
		}
		if (entry.exceptionStack) {
			entryHtml+='<tr><th>Exception Stack</th><td><code>'+encodeText(entry.exceptionStack)+'</code><td></tr>';
		}
		entryHtml+='</table>';
	}
	return entryHtml;
}

function encodeText(value)
{
	return String(value).replace(/[&<>"'`=\/]/g, function (s) {
		return entityMap[s];
	});
}

//Project Auditing 'Summary'
function popupSummaryDetail(event, id) {
	event.preventDefault();
	var projectKey=AJS.$('[name=projectKey]').attr('content');
	const jemhSummaryUrl=AJS.contextPath() + "/rest/jemh/latest/project/auditing/auditevent/summary/"+projectKey+"/"+id;
	let summaryJSON=AJS.$.getJSON(jemhSummaryUrl, {
		format: "json"
	});

	summaryJSON.done(function(data, textStatus, errorMessage) {
		if(data.errors) {
			console.error('popupReportDetail() errors');
		}
		else {
			let dialog = new AJS.Dialog({
				width: 1000,
				height: 800,
				id: "jemh-audit-summary-popup-dialog",
				closeOnOutsideClick: true
			});
			// adds header for first page
			dialog.addHeader("Summary");
			dialog.addPanel("Summary", "<div id='jemh-audit-summary-section-popup' class='jemh-audit-summary-section-popup'></div>", "panel-body");
			buildSummaryPage(data);

			// adds "Cancel" button to first page
			dialog.addButton("Close", function (dialog) {
				dialog.hide();
			});

			dialog.gotoPage(0);
			dialog.gotoPanel(0);
			dialog.show();
		}
	}).fail(function(data, textStatus, errorMessage) {
		console.error("popupSummaryDetail() failed: "+textStatus+" : "+jemhSummaryUrl);
	});
}

function buildSummaryPage(auditEvent){
	let summaryTable = "<table class='aui aui-table-rowhover maxWidth'>";
	summaryTable += "<tr><thead><th>Field</th><th>Value</th></thead></tr>";
	summaryTable += "<tr><td>Profile ID:</td><td>"+auditEvent.profileId+"</td></tr>";
	summaryTable += "<tr><td>Is Processed OK:</td><td>"+auditEvent.status+"</td></tr>";
	let isRejected;
	if (auditEvent.rejectReason !== null) {
		isRejected = "Y";
	} else {
		isRejected = "N";
	}
	summaryTable += "<tr><td>Is Rejected:</td><td>"+isRejected+"</td></tr>";
	summaryTable += "<tr><td>Process Status:</td><td>"+auditEvent.status+"</td></tr>";
	summaryTable += "<tr><td>Process Outcome:</td><td>"+auditEvent.processOutcome+"</td></tr>";
	summaryTable += "<tr><td>Hints:</td><td>";
	if (auditEvent.hasHints === "true") {
		summaryTable += auditEvent.hasHints+"</td></tr>";
	} else {
		summaryTable += "None</td></tr>";
	}
	if (auditEvent.mailSource === 0) {
		summaryTable += "<tr><td>Mail Source:</td><td>Mailbox</td></tr>";
	} else if (auditEvent.mailSource === 1) {
		summaryTable += "<tr><td>Mail Source:</td><td>Test Case</td></tr>";
	} else if (auditEvent.mailSource === 2) {
		summaryTable += "<tr><td>Mail Source:</td><td>API</td></tr>";
	} else if (auditEvent.mailSource === 3) {
		summaryTable += "<tr><td>Mail Source:</td><td>Re-animation</td></tr>";
	} else if (auditEvent.mailSource === 4) {
		summaryTable += "<tr><td>Mail Source:</td><td>Directive Set</td></tr>";
	} else {
		summaryTable += "<tr><td>Mail Source:</td><td>Unknown Mail Source</td></tr>";
	}
	if (auditEvent.rejectReason !== null) {
		summaryTable += "<tr><td>Can Handle:</td><td>Y</td></tr>";
	}
	else {
		summaryTable += "<tr><td>Can Handle:</td><td>N</td></tr>";
	}
	if (auditEvent.doDelete === "true") {
		summaryTable += "<tr><td>Should Delete:</td><td>Y</td></tr>";
	} else {
		summaryTable += "<tr><td>Should Delete:</td><td>N</td></tr>";
	}
	summaryTable += "<tr><td>Email Subject:</td><td>"+auditEvent.subject+"</td></tr>";
	summaryTable += "<tr><td>Message Size:</td><td>"+auditEvent.messageSize+"</td></tr>";

	let ruleType = auditEvent.mappingRuleType;
	if (typeof ruleType !== "undefined" ) {
		summaryTable += "<tr><td>Mapped Rule Type:</td><td>"+auditEvent.mappingRuleType+"</td></tr>";
	}
	let ruleVal = auditEvent.mappingRuleValue;
	if (typeof ruleVal !== "undefined" ) {
		summaryTable += "<tr><td>Mapped Rule Value:</td><td>"+auditEvent.mappingRuleValue+"</td></tr>";
	}
	let issueKey = auditEvent.issueKey;
	if (typeof issueKey !== "undefined") {
		summaryTable += "<tr><td>Issue Key:</td><td>" + auditEvent.issueKey + "</td></tr>";
	}
	summaryTable += "<tr><td>Created Issues:</td><td>"+auditEvent.createdIssues+"</td></tr>";
	summaryTable += "<tr><td>Updated Issues:</td><td>"+auditEvent.updatedIssues+"</td></tr>";
	summaryTable += "<tr><td>Commented Issues:</td><td>"+auditEvent.commentedIssues+"</td></tr>";
	summaryTable += "<tr><td>Processor Selected:</td><td>"+auditEvent.fieldProcessor+"</td></tr>";
	let exc = auditEvent.exception_;
	if (typeof exc !== "undefined") {
		summaryTable += "<tr><td>Exception:</td><td>"+auditEvent.exception_+"</td></tr>";
	}
	if (auditEvent.attachmentCount > 0) {
		summaryTable += "<tr><td>Attachment(s) Count:</td><td>"+auditEvent.attachmentCount+"</td></tr>";
	}
	let filterReason = auditEvent.filterReason;
	if (typeof filterReason !== "undefined") {
		summaryTable += "<tr><td>Filter Reason:</td><td>"+auditEvent.filterReason+"</td></tr>";
	}
	let filterName = auditEvent.filterName;
	if (typeof filterName !== "undefined") {
		summaryTable += "<tr><td>Filter Name:</td><td>"+auditEvent.filterName+"</td></tr>";
	}
	let filterAction = auditEvent.filterAction;
	if (typeof filterAction !== "undefined") {
		summaryTable += "<tr><td>Filter Action:</td><td>"+auditEvent.filterAction+"</td></tr>";
	}
	summaryTable += "<tr><td>Processing Time:</td><td>"+auditEvent.processingTime+"</td></tr>";
	summaryTable += "</table>";
	AJS.$('.jemh-audit-summary-section-popup').append(summaryTable);
}

AJS.$(document).ready( function() {

	if (document.location.href.indexOf('JEMHAuditingProjectTab')==-1)
	{
		console.log('JEMH Project : quiting project-auditing.js early due to JRA-32379');
		return;
	}
	else
	{
		console.log("JEMH Project : project-auditing.js loaded");

		if (document.location.href.indexOf('JEMHAuditingProjectTab!popupSearch.jspa')!=-1)
		{
			console.log('Due to JRA-32379, JEMH has to load project admin javascript into the admin context. Because of that, Popups need to also be in the admin context, and because of that we have to hide the Project Settings bit');
			AJS.$('.aui-page-header').hide();
		}
	}

	var lastAuditHistoryEventLoaded=0;
	var IMAGE_BASE=AJS.params.baseURL+'/download/resources/com.javahollic.jira.jemh-ui:jemh-images/icons';
	var projectKey=AJS.$('[name=projectKey]').attr('content');

	//NEW AJAX Audit History

	AJS.$('#jemh-audithistory-search-form').submit(function(e) {
		return false; //http://stackoverflow.com/questions/1357118/event-preventdefault-vs-return-false
	});

	AJS.$('#jemh-auditevents-latest-results-button').click(function(event) {
		lastAuditHistoryEventLoaded=0;
		event.preventDefault();
		AJS.$(".jemh-auditing-data-row").remove();
		pollServerForAuditEvents();
	});

	AJS.$('#jemh-auditevents-clear-results-button').click(function(event) {
		event.preventDefault();
		AJS.$(".jemh-auditing-data-row").remove();
	});

	AJS.$('#jemh-auditevents-page-size').change(function(ev) {
		event.preventDefault();
		var auditHistoryPageSize=AJS.$("#jemh-auditevents-page-size option:selected").val();
		while ( AJS.$("#jemh-auditevents-table > tbody > tr").length >=auditHistoryPageSize )
		{
			AJS.$("#jemh-auditevents-table > tbody > tr:last").remove();
		}
	});

	AJS.$('.jemh-search-method').change(function(ev) {
		AJS.$(".jemh-search-by-field").hide();
		var searchByClass=".jemh-search-by-id";
		var selectedSearchMethod = AJS.$(".jemh-search-method option:selected").val();

		switch (selectedSearchMethod) {
			case "ID":
				searchByClass=".jemh-search-by-id";
				break;
			case "ISSUE_KEY":
				searchByClass=".jemh-search-by-issueKey";
				break;
			case "SENDER":
				searchByClass=".jemh-search-by-sender";
				break;
			case "STATUS":
				searchByClass=".jemh-search-by-status";
				break;
			case "OUTCOME":
				searchByClass=".jemh-search-by-outcome";
				break;
			default:
				searchByClass=".jemh-search-by-id";
				break
		}

		AJS.$(searchByClass).show();
	});

	AJS.$('#jemh-auditevents-autoupdate').click(function() {
		if (this.checked) {
			restartAutoUpdate();
		} else {
			stopAutoUpdate();
		}
	});

	AJS.$('#jemh-event-update-period').change(function() {
		event.preventDefault();
		if (AJS.$('#jemh-auditevents-autoupdate').is(':checked')) {
			restartAutoUpdate();
		}
	});

	AJS.$( "#notBefore" ).datePicker({'overrideBrowserDefault': true});
	AJS.$( "#notAfter" ).datePicker({'overrideBrowserDefault': true});

	AJS.$('#searchButton').click(function(event) {
		//stop auto update
		executeHistorySearch();
	});

	AJS.$('#jemh-history-popup').click(function(event) {
		//stop auto update
		var strWindowFeatures = "location=yes,height=768,width=1024,scrollbars=yes,status=yes";
		var win = window.open(AJS.params.baseURL+'/secure/jemh/project/JEMHAuditingProjectTab!popupSearch.jspa?projectKey='+projectKey, "_blank", strWindowFeatures);
	});

	function executeHistorySearch() {

		//stop auto-update, reflect in UI
		stopAutoUpdate();
		AJS.$('#jemh-auditevents-autoupdate').removeAttr('checked');
		AJS.$(".jemh-auditing-data-row").remove();

		AJS.$('#jemh-auditevents-searchresults').html("<span class='aui-icon aui-icon-wait'>Loading, please wait</span>");

		//store page size in the form
		var auditHistoryPageSize=AJS.$("#jemh-auditevents-page-size option:selected").val()
		AJS.$('#pageSize').val(auditHistoryPageSize);

		// build data
		var postData=AJS.$('#jemh-audithistory-search-form').serialize();
		var formUrl = AJS.$('#jemh-audithistory-search-form').attr('action');

		// post
		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,
			dataType:"json",
			data:postData,
			timeout:30000});

		jqXHR.done(function(data, textStatus, errorThrown) {
			if(data.errors) {
				if (errorThrown)
				{
					console.error('auditevent Search Error: '+errorThrown);
				}
				else
				{
					console.error('auditevent Search Error');
				}
			} else {
				if (data.length>0) {
					console.log('got '+data.length+' records');
					var results = AJS.$.parseJSON(jqXHR.responseText);
					AJS.$('#jemh-auditevents-searchresults').html('&nbsp;&nbsp;<strong>Found '+data.length+' result(s)</strong>').fadeOut(5000, 0, function() {
						AJS.$('#jemh-auditevents-searchresults').html('').fadeIn();
					});

					displayResults(results);
				} else {
					AJS.$('#jemh-auditevents-searchresults').html('&nbsp;&nbsp;<strong>No results found</strong>').fadeOut(5000, 0, function() {
						AJS.$('#jemh-auditevents-searchresults').html('').fadeIn();
					});
				}
			}
		}).fail(function(data, textStatus, errorMessage) {
			console.error("executeHistorySearch("+data+") failed: "+textStatus+" : "+formUrl+", errorMessage: "+errorMessage);
		});
	}


	///
	///--------------- VALIDATED USED
	///

	function htmlEncode(value){
		//create a in-memory div, set it's inner text(which jQuery automatically encodes)
		//then grab the encoded contents back out.  The div never exists on the page.
		if (value)
		{
			return AJS.$('<div/>').text(value).html();
		}
		else
		{
			return 'no value';
		}
	}

	function htmlDecode(value)
	{
		return AJS.$('<div/>').html(value).text();
	}

	var msPerMinute = 60 * 1000;
	var msPerHour = msPerMinute * 60;
	var msPerDay = msPerHour * 24;
	var msPerMonth = msPerDay * 30;
	var msPerYear = msPerDay * 365;

	function timeDifference(current, previous) {

		var elapsed = current - previous;

		if (elapsed < msPerMinute) {
			return Math.round(elapsed/1000) + ' seconds ago';
		} else if (elapsed < msPerHour) {
			var val=Math.round(elapsed/msPerMinute);
			if (val>1) {
				return val+' minutes ago';
			} else {
				return 'a minute ago';
			}

		} else if (elapsed < msPerDay ) {
			var val=Math.round(elapsed/msPerHour);
			if (val>1) {
				return val+' hours ago';
			} else {
				return 'an hour ago';
			}
		} else if (elapsed < msPerMonth) {
			var val=Math.round(elapsed/msPerDay);
			if (val>1) {
				return 'about '+val+' days ago';
			} else {
				return 'about '+val+' day ago';
			}
		} else if (elapsed < msPerYear) {
			var val=Math.round(elapsed/msPerMonth);
			if (val>1) {
				return 'about '+val+' months ago';
			} else {
				return 'about '+val+' month ago';
			}
		} else {
			var val=Math.round(elapsed/msPerYear );
			if (val>1) {
				return 'about '+val+' years ago';
			} else {
				return 'about '+val+' year ago';
			}
		}
	}

	function renderLink(url, name) {
		return '<A HREF="'+url+'">'+name+'</A>';
	}
	function renderImageLink(url, name, imageName) {
		return '<A HREF="'+url+'" title="'+name+'"><IMG SRC="'+IMAGE_BASE+'/'+imageName+'"></IMG></A>';
	}
	function renderImageScriptLink(script, name, imageName) {
		return "<A HREF='#' onclick='"+script+"' title='"+name+"'><IMG SRC='"+IMAGE_BASE+"/"+imageName+"'></IMG></A>";
	}

	function getStatusFor(aRow)
	{
		var projectKey=AJS.$('[name=projectKey]').attr('content');
		var result='';
		const status = aRow.status;
		const reprocessed = aRow.reprocessed;

		if(status) {
			//remove this initial if condition when old statuses are no longer needed
			if(OldStatuses.includes(status)) {
				result = "<span class='aui-lozenge aui-lozenge-subtle'> OLD: "+status+"</span>";
			} else {
				switch (status) {
					case 'PROCESSED':
						result = "<A href='" + AJS.params.baseURL + "/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey=" + projectKey + "&id=" + aRow.id + "&customEditType=view-details&atl_token=" + AJS.$('#jemh-ajs-atl-token').val() + "' title='See Detail'>";
						result = result + "<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-success'>Processed</span>";
						// ... CHECK for HINTS
						if (aRow.hasHints) {
							result = result + "<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-complete'>Hints</span>";
						}
						result = result + "</A>";
						break;
					case 'RE_PROCESSED':
						result = "<table width='100%'><tr><td rowspan='2'></td><td><<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-complete'>Re-Processed</span></td></tr>";
						if (aRow.reprocNextId > 0) {
							result = result + "<tr><td><small>See id: " + aRow.reprocNextId + "</small></td></tr>";
						}
						result = result + "</table>";
						break;
					case 'INTERNAL_ERROR':
					case 'NOT_PROCESSED':
						result = "<span class='aui-lozenge'>"+status+"</span>";
						break;
					case 'FILTERED':
					case 'STOPPED':
					case 'UNKNOWN':
						result = "<span class='aui-lozenge aui-lozenge-error'>"+status+"</span>";
						break;
					case 'RUNNING':
						result = "<span class='aui-lozenge'>Running</span>";
						break;
					case 'HOLD':
						result = "<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-current'>On Hold</span>";
						break;
					default:
						result = "<span class='aui-lozenge aui-lozenge-error'>Unknown status: " + status + "</span>";
						break;
				}

				if(reprocessed && status !== 'RE_PROCESSED') {
					result = "<table width='100%'><tr><td rowspan='2'></td><td><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-complete'>Re-Processed</span></tr>";
					if (aRow.reprocNextId > 0) {
						result = result + "<tr><td><small>See id: " + aRow.reprocNextId + "</small></td></tr>";
					}
					result = result + "</table>";
				}
			}
		}else{
			result="<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-current'>Loading</span>";
		}

		return result;
	}

	function getOutcomeFor(aRow)
	{
		let result="<span class='aui-lozenge aui-lozenge-error'>Unknown status: "+aRow.processOutcome+"</span>";
		let processOutcome = aRow.processOutcome;

		if (processOutcome)
		{
			result = generateOutcomeLozenge(aRow);
		}

		return result;
	}

	function generateOutcomeLozenge(aRow)
	{
		let projectKey=AJS.$('[name=projectKey]').attr('content');
		let result='';
		let processOutcome = aRow.processOutcome;
		let status = aRow.status;
		let hasHints = aRow.hasHints;
		let isForwarded = aRow.forwarded;
		let hasExceptions = aRow.exception;
		let filterName='';
		let filterReason='';
		let filterAction='';
		//remove this boolean when old statuses are no longer needed
		let isOldRecord = false;

		if (aRow.filterName)
		{
			filterName=htmlEncode(aRow.filterName);
		}
		if (aRow.filterReason)
		{
			filterReason=htmlEncode(aRow.filterReason);
		}
		if (aRow.filterAction)
		{
			filterAction=htmlEncode(aRow.filterAction);
		}

		//remove this initial if condition when old statuses are no longer needed
		if(status && OldStatuses.includes(status)) {
			result="<span class='aui-lozenge aui-lozenge-error'>Unknown</span>";
		} else {
			if(processOutcome && !isOldRecord) {
				switch (processOutcome) {
					case 'SUCCESS':
						result = "<A href='" + AJS.params.baseURL + "/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey=" + projectKey + "&id=" + aRow.id + "&customEditType=view-details&atl_token=" + AJS.$('#jemh-ajs-atl-token').val() + "' title='See Detail'>";
						result = result + "<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-success'>Success</span>";
						// ... CHECK for HINTS
						if (hasHints) {
							result = result + "<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-complete'>Hints</span>";
						}
						result = result + "</A>";
						break;
					case 'FORWARDED':
					case 'IGNORED':
					case 'REJECTED':
						if (hasExceptions) {
							result=
								"<A href='"+AJS.params.baseURL+"/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey="+projectKey+"&id="+aRow.id+"&customEditType=view-details&atl_token="+AJS.$('#jemh-ajs-atl-token').val()+"' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'>" +
								"<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-moved'>"+processOutcome+"</span>" +
								"</A>";
						} else {
							result="<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-moved'>"+processOutcome+"</span>";
						}
						break;
					case 'DROP_AND_EXIT_GROUP':
					case 'DROPPED':
						if (filterName) {
							result="<A href='"+AJS.params.baseURL+"/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey="+projectKey+"&id="+aRow.id+"&customEditType=view-details&atl_token="+AJS.$('#jemh-ajs-atl-token').val()+"' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'>" +
								"<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-moved'>"+processOutcome+"</span>" +
								"<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'>"
						} else {
							result="<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-moved'>Dropped</span>";
						}
						break;
					case 'HOLD':
						result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-current'>On Hold</span></A>";
						break;
					case 'BLOCKED':
					case 'DELETED':
					case 'FOLDER_CLOSED':
					case 'REMOVED':
						result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'><span class='aui-lozenge aui-lozenge-subtle'>"+processOutcome+"</span></A>";
						break;
					case 'INTERNAL_ERROR':
					case 'EXCEPTION':
					case 'BUG':
						if(hasExceptions) {
							result="<A href='"+AJS.params.baseURL+"/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey="+projectKey+"&id="+aRow.id+"&customEditType=view-details&atl_token="+AJS.$('#jemh-ajs-atl-token').val()+"' title='"+aRow.exception+"'>";
						}
						result=result+"<span class='aui-lozenge aui-lozenge-error'>"+processOutcome+"</span></A>";
						break;
					default:
						result="<span class='aui-lozenge aui-lozenge-error'>Unknown</span>";
						break;
				}
			}
			else
			{
				result="<A href='#' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'><span class='aui-lozenge aui-lozenge-subtle aui-lozenge-current'>Loading</span></A>";
			}

			if(isForwarded && processOutcome != 'FORWARDED') {
				if (hasExceptions) {
					result=
						"<A href='"+AJS.params.baseURL+"/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey="+projectKey+"&id="+aRow.id+"&customEditType=view-details&atl_token="+AJS.$('#jemh-ajs-atl-token').val()+"' title='"+filterName+", action: "+filterAction+", reason: "+filterReason+"'>" +
						"<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-error'>Forwarded</span>" +
						"</A>";
				} else {
					result="<span class='aui-lozenge aui-lozenge-subtle aui-lozenge-error'>Forwarded</span>";
				}
			}
		}

		return result;
	}

	function buildDetail(arow) {
		var tr="<div class='jemh-detail-container'><div>";
		tr=tr+"<div id='jemh-detail-header'><span>";
		if (arow.subject) {
			if (arow.subject.length>60) {
				tr=tr+"<span title='"+htmlEncode(arow.subject)+"'>"+htmlEncode(arow.subject.substring(0,60))+" ...</span>";
			} else {
				tr=tr+htmlEncode(arow.subject);
			}
		} else {
			tr=tr+"";
		}
		tr=tr+"</span></div>";

		tr=tr+"</div>";
		return tr;
	}

	function pollServerForAuditEvents() {
		var auditHistoryPageSize=AJS.$('#jemh-auditevents-page-size option:selected').val();
		var pollUrl=AJS.params.baseURL+'/rest/jemh/latest/project/auditing/auditevent/latest/'+projectKey+'?lastReadId='+lastAuditHistoryEventLoaded+'&pageSize='+auditHistoryPageSize+'&atl_token='+AJS.$('#jemh-ajs-atl-token').val();

		AJS.$('#jemh-auditevents-searchresults').html("Checking...");

		var jqXHR=AJS.$.ajax({
			type:"GET",
			dataType:"json",
			contentType: "application/json; charset=utf-8",
			url:pollUrl,
			timeout:10000
		});

		jqXHR.done(function(data, textStatus, errorMessage) {
			if (data)
			{
				if(data.errors) {
					console.error('pollServerForAuditEvents() errors');
					AJS.$('#jemh-auditevents-searchresults').html("Comms problem");
				}
				else {
					displayResults(data);
					AJS.$('#jemh-auditevents-searchresults').html("");
				}
			}
			else
			{
				AJS.$('#jemh-auditevents-searchresults').html("");
			}

			AJS.$("#auditevents-lastupdated").text(new Date().toLocaleTimeString());

		}).fail(function(data, textStatus, errorMessage) {
			console.error("Poll failed: "+textStatus+" : "+pollUrl);
			stopAutoUpdate();
			AJS.$('#jemh-auditevents-autoupdate').removeAttr('checked');
			AJS.$('#errorMessage').show();
		});
	}

	function restartAutoUpdate() {
		clearInterval(refreshInterval);
		refreshInterval = setInterval(pollServerForAuditEvents, AJS.$('#jemh-event-update-period').val());
	}

	function stopAutoUpdate() {
		clearInterval(refreshInterval);
	}

	function displayResults(data) {
		var timeNow = new Date();
		var auditHistoryPageSize=AJS.$('#jemh-auditevents-page-size option:selected').val();
		var jemhDataRowCount=data.length;

		for (var i=jemhDataRowCount-1 ; i>=0 ; i--)
		{
			var arow=data[i];
			var msg='got a row - '+i+' with id: '+arow.id +" ";
			if (arow.createdIssues) { msg=msg+' created: '+arow.createdIssues; }
			if (arow.commentedIssues) { msg=msg+' commented: '+arow.commentedIssues; }
			if (arow.updatedIssues) { msg=msg+' updated: '+arow.updatedIssues; }
			if (arow.issueKey) { msg=msg+' with issueKey: '+arow.issueKey; }

			//console.info(msg);

			var tr = '<tr id="jemh-auditing-data-row_'+arow.id+'" class="jemh-auditing-data-row" >';
			var detailUrl=AJS.params.baseURL+'/secure/jemh/project/JEMHAuditingProjectTab!viewDetail.jspa?projectKey='+projectKey+'&id='+arow.id+'&atl_token='+AJS.$('#jemh-ajs-atl-token').val();

			//1
			tr=tr+'<td><A title="View Results" HREF='+detailUrl+'>'+arow.id+'</A></td>';

			//2
			tr=tr+'<td><a href="#" title="'+timeDifference(timeNow,arow.dateProcessedAsLong)+'">'+arow.dateProcessed+'</a></td>';

			//3
			tr=tr+'<td>';
			if (arow.fromAddress)
				tr=tr+'<small>'+arow.fromAddress+'</small>';
			else {
				tr=tr+"<strong>No Sender!</strong>";
			}
			tr=tr+'</td>';

			// 4 Details
			tr=tr+'<td>';
			tr=tr+buildDetail(arow);
			tr=tr+'</td>';

			// 5
			tr=tr+'<td>';
			if (arow.attachmentCount>0) {
				tr=tr+arow.attachmentCount;
			}
			tr=tr+'</td>';

			//6
			tr=tr+'<td>';
			if (typeof(arow.createdIssues) != "undefined" && arow.createdIssues.length>0) {
				tr=tr+'<small>Created: ';
				if (arow.createdIssues.length<=1) {
					tr=tr+'</small>';
				}
				for (j = 0; j < arow.createdIssues.length; j++) {
					tr=tr+renderLink(AJS.params.baseURL+'/browse/'+arow.createdIssues[j], arow.createdIssues[j])+'</A> ';
				}
				if (arow.createdIssues.length>1) {
					tr=tr+'</small>';
				}

			} else if (typeof(arow.commentedIssues) != "undefined" && arow.commentedIssues.length>0) {
				tr=tr+'<small>Commented: ';
				if (arow.commentedIssues.length<=1) {
					tr=tr+'</small>';
				}
				for (j = 0; j <  arow.commentedIssues.length; j++) {
					tr=tr+renderLink(AJS.params.baseURL+'/browse/'+ arow.commentedIssues[j],  arow.commentedIssues[j])+'</A> ';
				}
				if (arow.commentedIssues.length>1) {
					tr=tr+'</small>';
				}
			} else if (typeof(arow.updatedIssues) != "undefined" && arow.updatedIssues.length>0) {
				tr=tr+'<small>Updated: ';
				if (arow.updatedIssues.length<=1) {
					tr=tr+'</small>';
				}
				for (j = 0; j < arow.updatedIssues.length; j++) {
					tr=tr+renderLink(AJS.params.baseURL+'/browse/'+arow.updatedIssues[j], arow.updatedIssues[j])+'</A> ';
				}
				if (arow.updatedIssues.length>1) {
					tr=tr+'</small>';
				}
			}
			tr=tr+'</td>';

			//7
			tr=tr+'<td>';
			tr=tr+getOutcomeFor(arow);
			tr=tr+'</td>';
			tr=tr+'<td>';
			tr=tr+getStatusFor(arow);
			tr=tr+'</td>';


			//8

			/*'Operations' section of project auditing*/
			tr=tr+"<td><div class='jemh-auditevent-options' id='options_"+arow.id+"' style='display:none;'>";

			tr=tr+'</div>';
			tr=tr+"<ul class='operations-list'>";

			//Report (Processing Detail)
			tr=tr+"<li><a id='procReport_"+arow.id+"' href='#' title='Popup Processing Detail Report #"+arow.id+"' onclick='popupReportDetail(event,"+arow.id+");'>Report</a></li>";

			/*//Processing detail popup (Summary and report payload)
			tr=tr+renderImageLink(detailUrl, 'Processing Detail', 'properties.gif');
			tr=tr+"&nbsp;"*/

			//Export Unprocessed
			var unprocUrl=AJS.params.baseURL+'/secure/jemh/project/JEMHAuditingProjectTab!downloadMail.jspa?projectKey='+projectKey+'&id='+arow.id+'&getOriginal=on&atl_token='+AJS.$('#jemh-ajs-atl-token').val();
			tr=tr+"<li><a id='exportUnprocessed_"+arow.id+"' href='"+unprocUrl+"' title='Export Original Un-Processed email #"+arow.id+"' >Export</a></li>";

			//Dropdown button for more '...' options
			tr=tr+"<button class='aui-button aui-button-subtle aui-dropdown2-trigger aui-dropdown2-trigger-arrowless' aria-controls='jemh-audit"+arow.id+"-actions'><span class='aui-icon aui-icon-small aui-iconfont-more'>More actions</span></button>";
			tr=tr+"<aui-dropdown-menu id='jemh-audit"+arow.id+"-actions'>";

			//Summary (Processing Detail)
			tr=tr+"<li><a id='procSummary_"+arow.id+"' href='#' title='Popup Processing Detail Summary #"+arow.id+"' onclick='popupSummaryDetail(event,"+arow.id+");'>Summary</a></li>";

			//Email Details popup
			tr=tr+"<li><a id='emailDetails_"+arow.id+"' href='#' title='Popup Email Detail #"+arow.id+"' onclick='popupEmailDetail(event,"+arow.id+");'>Details</a></li>";

			//Export pre-processed
			if (arow.preprocessed) {
				var procUrl=AJS.params.baseURL+'/secure/jemh/project/JEMHAuditingProjectTab!downloadMail.jspa?projectKey='+projectKey+'&id='+arow.id+'&atl_token='+AJS.$('#jemh-ajs-atl-token').val();
				tr=tr+"<li><a id='exportPreProcessed_"+arow.id+"' href='"+procUrl+"' title='Export Post-Processed email #"+arow.id+"' >Export Post-Processed</a></li>";
			}

			//Test Case
			//Create Testcase
			var scr='createJemhTestCase("'+AJS.params.baseURL+'/rest/jemh/latest/project/auditing/auditevent/testcase/'+projectKey+'/'+arow.id+'?atl_token='+AJS.$("#jemh-ajs-atl-token").val()+'");';
			tr=tr+"<li><a id='createTestcase_"+arow.id+"' href='#' title='Create Test Case #"+arow.id+"' onclick='"+scr+"'>Create Test Case</a></li>";

			//Configure Profile
			if (arow.profileId>0) {
				let profileURL = AJS.params.baseURL+'/secure/jemh/project/JEMHConfiguration!view.jspa?projectKey='+projectKey+'&profileId='+arow.profileId+'&atl_token='+AJS.$('#jemh-ajs-atl-token').val();
				tr=tr+"<li><a id='configureProfile_"+arow.id+"' href='"+profileURL+"' title='Configure Profile #"+arow.id+"'>Configure Profile</a></li>";
			}

			//Reprocess
			if (arow.profileId>0) {
				tr=tr+"<li><a id='reprocess_"+arow.id+"' href='#' title='Reprocess Audit Event #"+arow.id+"' onclick='reprocessJemhAuditEvent(event,"+arow.id+");'>Reprocess</a></li>";
			}

			//Delete
			let deleteUrl = AJS.params.baseURL+'/secure/jemh/project/JEMHAuditingProjectTab!delete.jspa?projectKey='+projectKey+'&id='+arow.id+'&atl_token='+AJS.$('#jemh-ajs-atl-token').val();
			tr=tr+"<li><a id='delete_"+arow.id+"' href='"+deleteUrl+"' title='Delete Audit Event #"+arow.id+"'>Delete</a></li>";

			tr=tr+"</aui-dropdown-menu></ul></td>";
			/*End Operations section*/

			while ( AJS.$("#jemh-auditevents-table > tbody > tr").length >=auditHistoryPageSize )
			{
				AJS.$("#jemh-auditevents-table > tbody > tr:last").remove();
			}

			tr=tr+'</tr>';
			//.not(':first')
			AJS.$(tr).prependTo("#jemh-auditevents-table > tbody");
			var theRow="#jemh-auditing-data-row_"+arow.id;
			AJS.$(theRow).hover(
				function () {
					AJS.$(this).css("background","#f0f0f0");
					AJS.$(this).find('.jemh-auditevent-options').show();
				},
				function () {
					AJS.$(this).css("background","");
					AJS.$(this).find('.jemh-auditevent-options').hide();
				}
			);

			if (arow.id>lastAuditHistoryEventLoaded)
			{
				lastAuditHistoryEventLoaded=arow.id;
				//console.log("last read row is: "+lastAuditHistoryEventLoaded);
			}
		}
	}

	pollServerForAuditEvents();
	var refreshInterval = setInterval(pollServerForAuditEvents, AJS.$('#jemh-event-update-period option:selected').val());

});
