AJS.$(document).ready( function(){
	if (document.location.href.indexOf('JEMHStaticResourcesProjectTab')==-1)
	{
		console.log('JEMH Project : quiting project-staticresources.js early due to JRA-32379');
		return;
	}
	else
	{
		console.log("JEMH Project : project-staticresources.js loaded");
	}
	
	console.log("Static Resources script loading");
	
	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	var atl_token = AJS.$('#atl_token').val();

	AJS.$(".jemh-project-tab-staticresource-img").click(function(e) {
		console.log('click');
		e.preventDefault();
		var img = AJS.$(this);

		var title = img.attr('title');

		if (title === 'Click to close image') {
			img.attr('title', 'click to preview');
			img.attr('rendered', true).attr('src', '');
		} else {
			var id = img.attr('data');
			var url = baseUrl + "/rest/jemh/latest/staticresource/encode/" + id + "?atl_token=" + atl_token;

			var jqXHR = AJS.$.ajax({
				type: "GET",
				dataType: "text",
				contentType: "text/plain; charset=utf-8",
				url: url,
				timeout: 15000
			});

			jqXHR.done(function (data, textStatus, errorMessage) {
				img.attr('src', data).attr('title', 'Click to close image').attr('rendered', false);
			}).fail(function (data, textStatus, errorMessage) {
				console.error("Failed to get image preview: " + textStatus + ", status: " + jqXHR.status + ", response: " + jqXHR.responseText);
			});
		}
	});

	AJS.$("#createProjectStaticResourceButton").on("click", function () {
		var value = AJS.$("#resourceUpload").val();

		if (value) {
			AJS.$("#submitCreateProjectStaticResource").attr("disabled", false);
		} else {
			AJS.$("#submitCreateProjectStaticResource").attr("disabled", true);
		}
	});

	AJS.$("#resourceUpload").change(function(e) {
		var value = AJS.$("#resourceUpload").val();
	    if (value) {
	        AJS.$("#submitCreateProjectStaticResource").attr("disabled", false);
	    } else {
            AJS.$("#submitCreateProjectStaticResource").attr("disabled", true);
        }
	});

	//setup select
	AJS.$("#filterByProject").auiSelect2();
	//submit on change
	AJS.$("#filterByProject").change(function(e) {
		AJS.$("#jemhStaticResourcesFilterForm").submit();
	});

	function prepareOnEventActions() {
		AJS.$("#createProjectStaticResourceButton").on("click", function () {
			AJS.dialog2("#createProjectStaticResourcesDialog").show();
			console.log("Show dialog");
		});

		AJS.$("#cancelCreateProjectStaticResource").on("click", function () {
			AJS.dialog2("#createProjectStaticResourcesDialog").hide();
			console.log("Hide dialog");
		});
	}

	AJS.$("#submitCreateProjectStaticResource").on("click", function (e) {
		e.preventDefault();
		var formData = new FormData();
		if (AJS.$('#resourceUpload').prop('files').length > 0) {
			var file = AJS.$('#resourceUpload').prop('files')[0];
			var imgWidth = AJS.$('#imgWidth').val();
			var imgHeight = AJS.$('#imgHeight').val();
			var fileDescription = AJS.$('#fileDescription').val();
			let atl_token = AJS.$('input[name="atl_token"]').val();
			let projectKey = AJS.$('input[name="projectKey"]').val();
			formData.append('imageFile', file, file.name);

			console.log(" imageFile " + formData);

			var url = AJS.$('#postTaskFileUrl').val() + '?projectKey=' + projectKey + '&imgWidth=' + imgWidth + '&imgHeight=' + imgHeight + '&fileDescription=' + fileDescription + '&atl_token=' + atl_token;

			var jqXHR = AJS.$.ajax({
				type: 'post',
				url: url,
				data: formData,
				contentType: false,
				processData: false,
				timeout: 1200000, //20 mins timeout
			});

			jqXHR.done(function (data, textStatus, errorThrown) {
				// On success hide the dialog and then refresh the page to view the new PM
				AJS.dialog2("#createProjectStaticResourcesDialog").hide();
				location.reload();

			}).fail(function (data, textStatus, errorMessage) {
				// Provide info if the Project Mapping couldn't be created
				window.alert("Error when creating Static Recourse!");
				AJS.dialog2("#createProjectStaticResourcesDialog").hide();
			});
		}
		});

	prepareOnEventActions();
});			
