function buildAceEditor(formId, aceEditorDivId, aceStatusBarDivId, formTextAreaName, mode) {
	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	var editor0 = ace.edit(aceEditorDivId);
    editor0.setShowPrintMargin(false);
	editor0.setAutoScrollEditorIntoView();
	editor0.setOption("maxLines", 50);    
	editor0.setTheme("ace/theme/eclipse");
    editor0.getSession().setNewLineMode("unix");
    editor0.getSession().setMode("ace/mode/"+mode);												
	editor0.getSession().setUseSoftTabs(true);
	editor0.setDisplayIndentGuides(true);
	editor0.setShowInvisibles(true);
	//
	// transfer to form on save
	//
	AJS.$("#"+formId).submit(function( event ) {
		console.log('onSubmit, updating textarea['+formTextAreaName+']');
		var textarea = AJS.$('textarea[name="'+formTextAreaName+'"]');
		if(textarea)
		{
			textarea.val(editor0.getSession().getValue());
		}
		else
		{
			alert('textarea not found by name: '+formTextAreaName);
		}
	});
	
	//
	// create a simple caret status indicator
	//
    editor0.getSession().selection.on("changeCursor", function() { 
    	var position=editor0.selection.getCursor();
    	var msg=' '+(position.row+1)+' : '+position.column;
    	AJS.$('#'+aceStatusBarDivId+' > span[name="caret"]').text(msg);
    }); 
	
	//
	// Keyboard hooks
	//
	editor0.commands.addCommand({
	    name: 'Full Screen Toggle',
	    bindKey: {win: 'Ctrl-F11',  mac: 'Command-F11'},
	    exec: function(editor) {
				if (AJS.$('body').hasClass('fullScreen')==false) {
					AJS.$('body').toggleClass('fullScreen', 'add');
					AJS.$(editor.container).toggleClass('fullScreen-editor', 'add');
				}
				else {
					AJS.$('body').toggleClass('fullScreen', 'remove');
					AJS.$(editor.container).toggleClass('fullScreen-editor', 'remove');
				}														
				editor.resize();
	    },
	    readOnly: true // false if this command should not apply in readOnly mode
	});
		
	// Completion
	//Removed in JEMH-7749 Due to lack fo use
	/*var langTools = ace.require("ace/ext/language_tools");
    editor0.setOption("enableBasicAutocompletion", true);
    console.log('Setting up veloMatches');
    var veloMatches = {
        getCompletions: function (editor, session, pos, prefix, callback) {
            console.log('building prefix, starting with ['+prefix+']');
            if (prefix.startsWith('$') === true) {
                prefix = prefix.substring(1); // $this
            }

            AJS.$.getJSON(
                baseUrl + "/rest/jemh/latest/templateset/suggest?term=" + prefix,
                function (wordList) {
                    // wordList like [{"word":"flow","freq":24,"score":300,"flags":"bc","syllables":"1"}]
                    callback(null, wordList.map(function (ea) {
                        return {name: ea.word, value: ea.word, score: ea.score, meta: ea.meta}
                    }));
                })
        }
    };
    // http://stackoverflow.com/questions/26991288/ace-editor-autocompletion-remove-local-variables
    //langTools.addCompleter(veloMatches);
    //editor0.completers=[veloMatches,langTools.textCompleter];
    //editor0.completers=[veloMatches];*/

	return editor0;
}
