AJS.$(document).ready( function(){
	console.log('cfdefault.js loaded');

	let cfValueEditor;
	let cfData;
	let isRequestTypeCF;
	let isSelectCF;



	function isEvalulateButtonEnabled(Value) {
		if(Value === undefined || Value === "" || Value.length === 0){
				AJS.$("#scriptEvalButton"). attr("disabled", true);
				AJS.$("#cfdefault-evaluate-note").attr("hidden", false);
			}
		else {
			AJS.$("#scriptEvalButton"). attr("disabled", false);
			AJS.$("#cfdefault-evaluate-note").attr("hidden", true);
		}
	}


	function initAceEditor() {
		if (cfValueEditor === undefined) {
			cfValueEditor = buildAceEditor('jemhCustomFieldDefaultsForm', 'customFieldValue-editor', 'customFieldValue-statusBar', 'customFieldValue', 'javascript');
		}
	}

	function applyDefaultValueScript() {
		let editor = ace.edit("customFieldValue-editor");
		let cfDefaultValue = AJS.$("#cfDefaultValue").val();
		editor.setValue(cfDefaultValue);
	}

	function checkEngineAndLanguageValidation(languageVal, engineVal) {
		//Is Language compatible
		if(engineVal !== "" && languageVal !== ""){
			AJS.$('#ruleLanguageStatus').hide();
		}
		if (!engineVal) {
			AJS.$('#ruleLanguageStatus').removeClass('aui-lozenge-success').removeClass('aui-lozenge-error').text('No Engine Found');
			AJS.$('#ruleLanguageStatus').show();
		}
		if (!languageVal) {
			AJS.$('#ruleLanguageStatus').removeClass('aui-lozenge-success').removeClass('aui-lozenge-error').text('No Language Found');
			AJS.$('#ruleLanguageStatus').show();
		}
	}

	function submitChecker() {
			AJS.$("#cfdefault-submit-button").attr("disabled", false);
			let selectedType=AJS.$('#customFieldValueType').find(":selected").val();
		    let val=AJS.$('#customFieldValueInput').val();
			let textPresent = val === null && false && val === "";

			if (selectedType === "Script") {
				let languageValEngineVal = AJS.$(".jemhScriptLanguage").find(":selected").val();
				if (languageValEngineVal === "" || textPresent) {
					AJS.$("#cfdefault-submit-button"). attr("disabled", true);
				} else {
					AJS.$("#cfdefault-submit-button"). attr("disabled", false);
				}
			}

	}

	function evalChecker() {
		AJS.$("#scriptEvalButton").attr("disabled", false);
		let selectedType=AJS.$('#customFieldValueType').find(":selected").val();
		if (selectedType === "Script") {
			let languageValEngineVal = AJS.$(".jemhScriptLanguage").find(":selected").val();

			AJS.$(".script-section").attr("hidden", false);
			if (languageValEngineVal === "" || languageValEngineVal === undefined || languageValEngineVal.length === 0) {
				AJS.$("#scriptEvalButton"). attr("disabled", true);
			}
		} else {
			AJS.$(".script-section").attr("hidden", true);
		}
	}

	function showTextbox() {
		AJS.$(".jemh-option-selector").auiSelect2('destroy');
		AJS.$("#jemh-cfOptions").empty();
		AJS.$(".jemh-text-based").show();
		initAceEditor();
	}

	function showCFOptions(id){
		if (isRequestTypeCF) {
			getRequestTypeOptions(id);
		} else {
			getSelectOptions(id);
		}
	}

	function getRequestTypeOptions(id)
	{
		let initVal = AJS.$("#cfValue").val();
		let spinTimer;
		let url = AJS.contextPath() + "/rest/jemh/latest/api/config/data/customfield/" + id + "?projectKey=" + AJS.$('#projKey').val() +
			"&issueTypeName=" + AJS.$("#issueTypeName").val() + "&atl_token=" + AJS.$('#atl_token').val();
		AJS.$.ajax({
			url: url,
			beforeSend: function () {
				spinTimer = setTimeout(function () {
					AJS.$('#jemh-option-spin').spin("medium");
				}, 250);
			}
		})
			.done(function (data) {

				let select = AJS.$("#customFieldRequestValuesSelect");
				select.empty();
				select.append($('<option>', {
					value: "",
					text: "None",
					selected: true
				}));

				if (data !== undefined) {
					cfData = data;
					if (cfData.dateBased) {
						AJS.$("#textValueDesc").text("Date and DateTime values should be entered in the JDBC format: yyyy-mm-dd hh:mm:ss.fffffffff").show();
					} else {
						AJS.$("#textValueDesc").hide();
					}
					if (cfData.options !== undefined && cfData.options.length > 0) {
						cfData.options.forEach(function (option) {
							let selected = false;
							if (option.value === initVal) {
								selected = true;
							}
							select.append($('<option>', {
								value: option.value,
								text: option.name,
								selected: selected
							}));
						});
					}
				}
			})
			.fail(function () {
				AJS.log("Failed to retrieve options for " + id);
			})
			.always(function () {
				clearTimeout(spinTimer);
				AJS.$('#jemh-option-spin').spinStop();
			});
	}

	function getSelectOptions(id)
	{
		let initVal = AJS.$("#cfValue").val();
		let spinTimer;
		let url = AJS.contextPath() + "/rest/jemh/latest/api/config/data/select/customfield/" + id + "?projectKey=" + AJS.$('#projKey').val() +
			"&issueTypeName=" + AJS.$("#issueTypeName").val() + "&atl_token=" + AJS.$('#atl_token').val();
		AJS.$.ajax({
			url: url,
			beforeSend: function () {
				spinTimer = setTimeout(function () {
					AJS.$('#jemh-option-spin').spin("medium");
				}, 250);
			}
		})
			.done(function (data) {

				let select = AJS.$("#customFieldRequestValuesSelect");
				select.empty();
				select.append($('<option>', {
					value: "",
					text: "None",
					selected: true
				}));

				if (data !== undefined) {
					cfData = data;
					if (cfData.dateBased) {
						AJS.$("#textValueDesc").text("Date and DateTime values should be entered in the JDBC format: yyyy-mm-dd hh:mm:ss.fffffffff").show();
					} else {
						AJS.$("#textValueDesc").hide();
					}
					if (cfData.options !== undefined && cfData.options.length > 0) {
						cfData.options.forEach(function (option) {
							let selected = false;
							if (option.value === initVal) {
								selected = true;
							}
							select.append($('<option>', {
								value: option.value,
								text: option.name,
								selected: selected
							}));
						});
					}
				}
			})
			.fail(function () {
				AJS.log("Failed to retrieve options for " + id);
			})
			.always(function () {
				clearTimeout(spinTimer);
				AJS.$('#jemh-option-spin').spinStop();
			});
	}

	function setupView() {
		submitChecker();
		evalChecker();

		let selectedType=AJS.$('#customFieldValueType').find(":selected").val();
		let initialValue = AJS.$("#initialCustomFieldValueInput").val();
		let cfInitialValueType = AJS.$("#initialCustomFieldValueType").val();
		
		
	

		if (cfInitialValueType !== "Script" && selectedType === "Script") {
			applyDefaultValueScript();
		} else if(initialValue === undefined || initialValue === "" || initialValue.length === 0) {
			if (cfInitialValueType === "Script" && selectedType === "Script") {
				applyDefaultValueScript();
			}
		}

		if (selectedType === "Velocity") {
			AJS.$('#customFieldValueLabel').attr("hidden", false);
			AJS.$('#cfdefault-edit-wrapper').width('100%');
			AJS.$('.cfdefault-script-eval').attr("hidden", false);
			AJS.$('.cfscript-custom-field-value').attr("hidden", false);
			AJS.$('.script-section').attr("hidden", true);
			AJS.$('.cfscript-field-tools').attr("hidden", false);
			AJS.$('#evalInfo').attr("hidden", true);
			AJS.$('#evalVelocityInfo').attr("hidden", true);		
			showTextbox();
			loadCustomFieldContext('customfield');
			
			AJS.$('#cfdefault-edit-wrapper').attr("hidden", false);
			AJS.$('#customFieldRequestValuesSelectDiv').attr("hidden", true);
		} else if (selectedType === "Script") {
			AJS.$('#evalVelocityInfo').attr("hidden", true);
			AJS.$('#customFieldValueLabel').attr("hidden", false);
			AJS.$('#cfdefault-edit-wrapper').width('100%');
			AJS.$('.cfdefault-script-eval').attr("hidden", false);
			AJS.$('.cfscript-custom-field-value').attr("hidden", false);
			AJS.$('.script-section').attr("hidden", false);
			AJS.$('.cfscript-field-tools').attr("hidden", false);

			let initialValue = AJS.$("#initialCustomFieldValueInput").val();
			let customFieldValue = AJS.$("#customFieldValueInput").val();

			if (initialValue === customFieldValue) {
				AJS.$('#evalInfo').attr("hidden", false);
			}
			AJS.$('#evalInfo').attr("hidden", true);
			showTextbox();
			loadCustomFieldContext('scripcfdefault');

			AJS.$('#cfdefault-edit-wrapper').attr("hidden", false);
			AJS.$('#customFieldRequestValuesSelectDiv').attr("hidden", true);
		} else {
			AJS.$('#evalInfo').attr("hidden", true);
			AJS.$('#evalVelocityInfo').attr("hidden", true);
			isRequestTypeCustomField();
		}
	}

	function addChildOptions(parentSelector) {
		if (parentSelector.prop("selectedIndex") > 0 && cfData !== undefined && cfData.options[parentSelector.prop("selectedIndex") - 1].hasOwnProperty("children")) {
			cfData.options[parentSelector.prop("selectedIndex") - 1].children.forEach(function(item, idx) {
				AJS.$("#jemh-child-selector").prop("options")[AJS.$("#jemh-child-selector").prop("options").length] = new Option(item.value,item.value);
			});
		}
	}

	AJS.$("#jemh-cfOptions").on("change", "#jemh-parent-selector", function(e) {
		if (AJS.$("#jemh-child-selector").length > 0) {
			AJS.$("#jemh-child-selector").prop("length", 1);
			AJS.$("#jemh-child-selector").auiSelect2("val", "");
			if (this.selectedIndex > 0) {
				addChildOptions(AJS.$(this));
			}
		}
	});

	//Script Language
	AJS.$(".scriptLanguage").change(function(){
		let languageValEngineVal = AJS.$(".scriptLanguage").find(":selected").val();
		if(languageValEngineVal){
			let engineVal = "";
			let languageVal = languageValEngineVal.split("_")[0];
			if (languageValEngineVal.length > 1) {
				engineVal = languageValEngineVal.split("_")[1];
			}
			AJS.$("#scriptLanguageVal").val(languageVal);
			AJS.$("#scriptEngineVal").val(engineVal);
			checkEngineAndLanguageValidation(languageVal, engineVal);
		}
	});


	AJS.$("#testCasePicker").change(function(){
		AJS.$('#evalVelocityInfo').attr("hidden", true);
		AJS.$('#evalInfo').attr("hidden", true);	
			
	});



	AJS.$("#scriptEvalButton").click(function(e) {
		e.preventDefault();
		let val=cfValueEditor.getSession().getValue();
		let testCaseId = AJS.$('#testCasePicker').find(":selected").val();
		let selectedType=AJS.$('#customFieldValueType').find(":selected").val();
		if (selectedType==="Velocity") {
			AJS.$('#velocityMarkup').val(val);
			AJS.$('#testCaseId').val(testCaseId);
			let postData=AJS.$('#jemhPreviewDataForm').serialize();
			let formUrl = AJS.$('#jemhPreviewDataForm').attr('action');
			let jqXHR=AJS.$.ajax({
				type:"POST",
				url:formUrl,
				dataType:"text",
				data:postData,
				timeout:60000
			});

			jqXHR.done(function(data, textStatus, errorThrown) {
				
				warningOutputDiv = "#velocityWarningOutput";				
				AJS.$('#cfdefault-custom-field-text').val(data);
				let customFieldValueText = AJS.$('#cfdefault-custom-field-text').val();		
				let isDataAnError = customFieldValueText.includes("An error occurred whilst rendering this message.  Please contact the administrators, and inform them of this bug.");
				
				if (!customFieldValueText)
				{
					AJS.$(warningOutputDiv).css({border: "3px solid #DE350B"});
					AJS.$(warningOutputDiv).text("Current Custom Field Value is empty");
					AJS.$("#evalVelocityInfo").show();
					AJS.$('#evalVelocityInfo').attr("hidden", false);	
				}
				else if (isDataAnError)
				{
					AJS.$(warningOutputDiv).css({border: "3px solid #DE350B"});
					AJS.$(warningOutputDiv).text(data);
					AJS.$('#cfdefault-custom-field-text').val("");
					AJS.$("#evalVelocityInfo").show();
					AJS.$('#evalVelocityInfo').attr("hidden", false);	
				}
				else
				{
					AJS.$("#evalVelocityInfo").hide();
					AJS.$('#evalVelocityInfo').attr("hidden", true);	
				}
				
			});
		} else if(selectedType === "Script") {

			let languageEngine = AJS.$(".jemhScriptLanguage").find(":selected").val();
			let currentLanguage =languageEngine.split("_")[0];
			let currentEngine = "";
			if (languageEngine.length > 1) {
				currentEngine =languageEngine.split("_")[1];
			}

			let consoleLogDiv = "#ruleValidationConsole";
			AJS.$(consoleLogDiv).css({border: "3px solid #CCCCCC"});
			AJS.$(consoleLogDiv).text("Running, please wait...");

			if(!testCaseId)
			{
				AJS.$('#ruleValidationStatus').removeClass('aui-lozenge-success').addClass('aui-lozenge-error').text('NO TEST CASE SELECTED');
				AJS.$(consoleLogDiv).empty();
				return;
			}

			AJS.$("#jemhScriptCfDefaultDataForm [name=testCaseId]").val(testCaseId);
			AJS.$("#jemhScriptCfDefaultDataForm [name=scriptContent]").val(val);
			AJS.$("#jemhScriptCfDefaultDataForm [name=scriptLanguage]").val(currentLanguage);
			AJS.$("#jemhScriptCfDefaultDataForm [name=scriptEngine]").val(currentEngine);
			AJS.$('#testCaseId').val(testCaseId);

			let postData=AJS.$('#jemhScriptCfDefaultDataForm').serialize();
			let formUrl = AJS.$('#jemhScriptCfDefaultDataForm').attr('action');
			let jqXHR=AJS.$.ajax({
				type:"POST",
				url:formUrl,
				dataType:"json",
				data:postData,
				timeout:60000
			});

			jqXHR.done(function(data) {
				AJS.$("#evalInfo").show();

				AJS.$("#mailProcessingDuration > div").text(data.duration+" ms [engineInit="+data.scriptEngineInitTime
					+"ms,  scriptCompile="+data.scriptCompileTime
					+"ms, scriptEval="+data.scriptEngineEvalTime+"ms]").html();

				if (data.exception)
				{
					AJS.$(consoleLogDiv).css({border: "3px solid #DE350B"});
					AJS.$('#ruleValidationStatus').removeClass('aui-lozenge-success').addClass('aui-lozenge-error').text('ERROR');
					AJS.$(consoleLogDiv).text(data.exception);
				}
				else
				{
					AJS.$(consoleLogDiv).css({border: "3px solid #00875A"});
					if (data.consoleLog)
					{
						AJS.$(consoleLogDiv).text(data.consoleLog);
					}
					else
					{
						AJS.$(consoleLogDiv).text("Script returned no console output");
					}
				}

			}).fail(function(data, textStatus, errorMessage) {
				console.log("Script execution failed: textStatus="+textStatus+", errorMessage: "+errorMessage);
				AJS.$(consoleLogDiv).text('');
				AJS.messages.generic(consoleLogDiv, {
					title:"Script rendering failed",
					body: '<p>Status: '+textStatus+', error: '+errorMessage+'</p>'
				});
			});

			jqXHR.done(function(data, textStatus, errorThrown) {
				AJS.$('#cfdefault-custom-field-text').val(data.value);
				AJS.$("#evalInfo").attr("hidden", false);
			});
		}
		return false;
	});

	//loaded when "Field Value Type" changes
	function setValueByType() {
		let selectedType=AJS.$('#customFieldValueType').find(":selected").val();
		let currentValue;
		if (selectedType === "Velocity") {
			currentValue = AJS.$('#currentVelocityValue').val();			
		
		} else if (selectedType === "Script") {
			currentValue = AJS.$('#currentScriptValue').val();

			if (currentValue === undefined || currentValue === "" || currentValue.length === 0) {
				currentValue = AJS.$('#cfDefaultValue').val();
			}
		} else {
			if (isRequestTypeCF || isSelectCF) {
				currentValue = AJS.$("#customFieldRequestValuesSelect").find(":selected").val();
			} else {
				currentValue = AJS.$("#currentTextValue").val();
			}
        }

		let editor = ace.edit("customFieldValue-editor");
		editor.setValue(currentValue);
		isEvalulateButtonEnabled(currentValue);
	}
	//when the "Value" field changes
	function setInputValue(inputValue) {
		let selectedType=AJS.$('#customFieldValueType').find(":selected").val();
		if (selectedType === "Velocity") {
			AJS.$('#currentVelocityValue').val(inputValue);
			isEvalulateButtonEnabled(inputValue);
		} else if (selectedType === "Script") {
			AJS.$('#currentScriptValue').val(inputValue);			
			isEvalulateButtonEnabled(inputValue);			
		} else {
			AJS.$('#currentTextValue').val(inputValue);
		}
	}
	function isRequestTypeCustomField()
	{
		let id = AJS.$('#customFieldId').val();
		let url = AJS.contextPath() + "/rest/jemh/latest/api/config/isRequestTypeCF?id="+id + "&atl_token="+AJS.$('#atl_token').val();
		let jqXHR = AJS.$.ajax({
			type:"GET",
			url:url,
			timeout:60000
		});

		jqXHR.done(function(data) {

			AJS.$('.cfdefault-script-eval').attr("hidden", true);
			AJS.$('.cfscript-custom-field-value').attr("hidden", true);
			AJS.$('.cfscript-field-tools').attr("hidden", true);
			AJS.$('#cfdefault-edit-wrapper').attr("hidden", true);
			isRequestTypeCF = data;
			 if (!isRequestTypeCF) {
				 isSelectCustomField();
			} else {
				 showCFOptionsAndUI();
			}

		});
	}

	function isSelectCustomField()
	{
		let id = AJS.$('#customFieldId').val();
		let url = AJS.contextPath() + "/rest/jemh/latest/api/config/isSelectCF?id="+id + "&atl_token="+AJS.$('#atl_token').val();
		let jqXHR = AJS.$.ajax({
			type:"GET",
			url:url,
			timeout:60000
		});

		jqXHR.done(function(data) {

			AJS.$('.cfdefault-script-eval').attr("hidden", true);
			AJS.$('.cfscript-custom-field-value').attr("hidden", true);
			AJS.$('.cfscript-field-tools').attr("hidden", true);
			AJS.$('#cfdefault-edit-wrapper').attr("hidden", true);

			isSelectCF = data;

			if (!isSelectCF) {
				showTextbox();
				AJS.$('#cfdefault-edit-wrapper').attr("hidden", false);
				AJS.$('.cfscript-custom-field-value').attr("hidden", true);
				AJS.$('#customFieldRequestValuesSelectDiv').attr("hidden", true);
				AJS.$('#customFieldValueLabel').attr("hidden", false);
			} else {
				showCFOptionsAndUI();
			}

		});
	}

	function showCFOptionsAndUI()
	{
		showCFOptions(AJS.$('#customFieldId').val());

		AJS.$('.jemh-scriptcontext').hide();
		AJS.$('#cfdefault-edit-wrapper').width('500px');
		AJS.$('.cfdefault-script-eval').attr("hidden", true);
		AJS.$('#customFieldValueLabel').attr("hidden", true);
		AJS.$('.script-section').attr("hidden", true);
		AJS.$('.cfscript-field-tools').attr("hidden", true);
		AJS.$('.cfscript-custom-field-value').attr("hidden", true);

		AJS.$('#cfdefault-edit-wrapper').attr("hidden", true);
		AJS.$('#customFieldRequestValuesSelectDiv').attr("hidden", false);
	}

	AJS.$("#customFieldValueType, #customFieldId").change(function(e) {
		setupView();
        setValueByType();
	});

	AJS.$("#jemhScriptLanguage").on("click", function () {
		submitChecker();
		evalChecker();
	});

	AJS.$("#customFieldValue-editor").on('keyup', function () {
		let editor = ace.edit("customFieldValue-editor");
		let val = editor.getValue();
		AJS.$('#customFieldValue').val(val);
		setInputValue(val);
		submitChecker();
	});

	AJS.$("#cfdefault-submit-button").on('click', function () {
		if (isRequestTypeCF || isSelectCF) {
			let value = AJS.$("#customFieldRequestValuesSelect").val();
			if (cfValueEditor !== undefined) {
				cfValueEditor.getSession().setValue(value);
				let editor = ace.edit("customFieldValue-editor");
				editor.setValue(value);
			}
			AJS.$("#customFieldValueInput").val(value);
			AJS.$('#customFieldValue').val(value);
			setInputValue(value);
			submitChecker();
		}
	});

	AJS.$("#customFieldId").auiSelect2();
	let editor = ace.edit("customFieldValue-editor");
	let val = editor.getValue();

	AJS.$("#customFieldValueInput").val(val);
	AJS.$("#initialCustomFieldValueInput").val(val);

	submitChecker();
	setupView();
	let initialCustomFieldValueInput = AJS.$("#initialCustomFieldValueInput").val();
    setInputValue(initialCustomFieldValueInput);
    setValueByType();
});
