AJS.$(document).ready(function () {
    let paramsValid = true;

    function prepareOnEventActions() {

        AJS.$("#createDomainRuleButton").on("click", function () {
            AJS.dialog2("#addDomainRuleDialog").show();
            submitChecker();
        });

        AJS.$("#createDomainRuleCancelButton").on("click", function () {
            AJS.dialog2("#addDomainRuleDialog").hide();
            submitChecker();
        });

        AJS.$("#submitCreateDomainRule").on("click", function () {
            paramsValid = true;

            let projectKey = AJS.$("#projectKey").val()
            let profileId = AJS.$("#profileId").val();
            let emailDomainRule = AJS.$('#emailDomainRule').val();
            let description = AJS.$('#description').val()[0];

            let isAddresseePopup = AJS.$('#jemhDomainAddressee').attr("checked");
            let isSenderPopup = AJS.$('#jemhDomainSender').attr("checked");

            if (paramsValid) {
                console.log("Validating profileId... value is: " + profileId);
                paramsValid = validateParam(profileId);
            }

            if (paramsValid) {
                console.log("Validating projectKey... value is: " + projectKey);
                paramsValid = validateParam(projectKey);
            }

            if (paramsValid) {
                console.log("Validating emailDomainRule... value is: " + emailDomainRule);
                paramsValid = validateParam(emailDomainRule);
            }

            if (paramsValid) {
                paramsValid = validateParam(isAddresseePopup) || validateParam(isSenderPopup);
                console.log("Validating isAddressee... value is: " + isAddresseePopup);
                console.log("Validating isSender... value is: " + isSenderPopup);

                submitCreateNewDomainRule(isAddresseePopup);
            } else {
                console.error("One of your parameters is invalid.")
            }
        });
    }

    AJS.$("#emailDomainRule").on('keyup', function () {
        submitChecker();
    });

    function submitChecker() {
        let emptyValue = true;
        let emailDomainRule = AJS.$('#emailDomainRule').val();

        if (emailDomainRule === null || emailDomainRule === undefined || emailDomainRule === "") {
            console.log("param: " + emailDomainRule + " is invalid");
            emptyValue = false;
        }

        if (emptyValue) {
            AJS.$("#submitCreateDomainRule"). attr("disabled", false);
        } else {
            AJS.$("#submitCreateDomainRule"). attr("disabled", true);
        }
    }

    function submitCreateNewDomainRule(isAddressee) {
        AJS.$("#jemhDomainRulePopupForm [name=addressType]").val(isAddressee);
        var postData = AJS.$('#jemhDomainRulePopupForm').serialize();
        var formUrl = AJS.$('#jemhDomainRulePopupForm').attr('action');

        //contentType: sent to the server as a header
        //dataType is the response
        var jqXHR = AJS.$.ajax({
            type: "POST",
            url: formUrl,
            data: postData,
        }); //post

        jqXHR.done(function (data, textStatus, errorThrown) {
            // On success hide the dialog and then refresh the page to view the new PM
            AJS.dialog2("#addDomainRuleDialog").hide();
            location.reload();

        }).fail(function (data, textStatus, errorMessage) {
            // Provide info if the Project Mapping couldn't be created
            window.alert("Error when creating Project Mapping!");
            AJS.dialog2("#addDomainRuleDialog").hide();
        });
    }

    function validateParam(param) {
        let result = true;
        if (param === null || param === undefined || param === "" || param === "(none)") {
            console.log("param: " + param + " is invalid");
            result = false;
        }
        return result;
    }

    prepareOnEventActions();
    submitChecker();
});