AJS.$(document).ready( function(){
	console.log('eventlistener.js loaded');
    var atl_token = AJS.$('#atlassian-token').attr('content');
    var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	
	AJS.$(this).find('.jemh-profile-options').hide();
	AJS.$(".jemh-profile-row").each(function() {
		AJS.$( this ).hover(
		  function () {
		    AJS.$(this).css("background","#f0f0f0");
		    AJS.$(this).find('.jemh-profile-options').show();
		  },
		  function () {
		    AJS.$(this).css("background","");
		    AJS.$(this).find('.jemh-profile-options').hide();
		  }
		);
	});

	AJS.$(".edit-mail-handler").click(function(e) {
		e.preventDefault();
		var handlerEditUrl = AJS.$('#jemhTemplatePreviewDataForm').attr('href');
		
		var jqXHR=AJS.$.ajax({
			type:"GET",
			dataType:"text/html",
			contentType: "text/html; charset=utf-8",
			url: handlerEditUrl,								
			timeout:15000});
		
		jqXHR.done(function(data) {
			AJS.InlineDialog(AJS.$(".edit-mail-handler"), "Handler Settings",
				    function(content, trigger, showPopup) {
				        content.css({"padding":"20px"}).html(data);
				        showPopup();
				        return false;
				    }
				);
		}).fail(function(data, textStatus) {
			enableAuditPurgeButton();
			console.log("MailHandlerEdit lookup failed: "+textStatus+", status: "+jqXHR.status+", response: "+jqXHR.responseText);
		});		
		
		
	});

	AJS.$(".jemh-transport-ping").click(function(event) {
		console.log('ping() clicked');
		event.preventDefault();
		var theId=this.id;		
		var splitVar=theId.split("_");
		var transportKey=splitVar[1];
		var configId=splitVar[2];
		console.log("transportKey="+transportKey+", id="+configId);
		
		AJS.$.get(baseUrl+"/rest/jemh/latest/eventlistener/transport/ping/"+transportKey+"/"+configId+ "?atl_token="+atl_token, function(data) {
			console.log('all done: '+data.detail);
			
			if (!data.error) {
				AJS.messages.success("#transport-message-bar",{
				    title: "Success!",
				    body: "Transport "+transportKey+" with config #"+configId+" was pinged successfully",
				    closeable: 'true',
				    fadeout: 'true',
				    delay: 2000
				});
			} else {
				AJS.messages.error("#transport-message-bar",{
				    title: "Ping Fail!",
				    body: "Transport could not be pinged: "+data.error+", detail: "+data.detail,
				    closeable: 'true',
				    fadeout: 'true',
				    delay: 2000
				});				
			}
		});		
	});
	
	// background update using REST of individual transport status
	AJS.$(".transport-service-state").each(function() {
		var theId=this.id;		
		var splitVar=theId.split("_");
		var transportKey=splitVar[1];
		var configId=splitVar[2];
		console.log("checking transportKey="+transportKey+", id="+configId);
		
		AJS.$.get(baseUrl+"/rest/jemh/latest/eventlistener/transport/check/"+transportKey+"/"+configId+ "?atl_token="+atl_token, function(data) {
			if (data.serviceState==='UP') {
				console.log("transportKey="+transportKey+", id="+configId+" is UP");
				AJS.$("#"+theId).attr('style','background-color: green; color: white');
				AJS.$("#"+theId).html('UP');
			} else {
				console.log("transportKey="+transportKey+", id="+configId+" is DOWN");
				AJS.$("#"+theId).attr('style','background-color: red; color: white');
				AJS.$("#"+theId).html('DOWN <pre> ('+data.lastError+' )</pre>');
			}
		});
	});
	
	AJS.$(".renderTemplateInfo").click(function()
	{
		var mappingId = AJS.$(this).parent().parent().siblings("#mappingId").val();
		var transportKey = "default-email";
		var requestData = null;
		if (AJS.$(this).hasClass("jira"))
		{
			requestData = { type:"jira" };
		}
		else if (AJS.$(this).hasClass("nonJira"))
		{
			requestData = { type:"nonjira" };
		}
		
		AJS.dialog2("#templates-dialog").show();
		
		AJS.$.get(baseUrl+"/rest/jemh/latest/eventlistener/transport/"+transportKey+"/"+mappingId+"/renderTemplateInfo"+ "?atl_token="+atl_token, requestData, function(data)
		{
		    console.log(data);
			AJS.$("#templates-dialog").children(".aui-dialog2-content").empty().html(data);
						
			var mappingProjects = AJS.$("ul[id=project-heading-list-"+mappingId+"]").clone().wrap("<p/>").parent().html();
			
			AJS.$(".aui-dialog2-header-main").html("Active templates for:"+mappingProjects);
			AJS.$(".aui-dialog2-header-main").find("li:nth-child(3)").nextAll().remove();
		});
	});
	
	AJS.$("#dialog-close-button").click(function(e) {
    	e.preventDefault();
    	AJS.dialog2("#templates-dialog").hide();
	});

	AJS.$(".aui-iconfont-close-dialog").click(function(e) {
			e.preventDefault();
			AJS.dialog2("#templates-dialog").hide();
	});

	AJS.$(".import-dialog-close-button").click(function(e) {
		closeImportDialog(e);
	});

	AJS.$('#jemh-directiveset-import').on('click', function() {
		let importDialog = AJS.$('#jemh-directiveset-import-dialog');
		if (importDialog.attr('id') != null) {
			AJS.dialog2('#jemh-directiveset-import-dialog').show();
		}
	});

	AJS.$(document).keyup(function(e){
		if(e.keyCode === 27)
		{
			closeImportDialog(e);
		}
	});

	function closeImportDialog(e) {
		e.preventDefault();
		AJS.$('#uploadFile').val('');
		AJS.dialog2('#jemh-directiveset-import-dialog').hide();
	}
});			
