var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
var entityMap = {
		  '&': '&amp;',
		  '<': '&lt;',
		  '>': '&gt;',
		  '"': '&quot;',
		  "'": '&#39;',
		  '/': '&#x2F;',
		  '`': '&#x60;',
		  '=': '&#x3D;'
		};

function updateFormSelect(fieldOptions, fieldIdStr) {
	var targetSelect = AJS.$("#" + fieldIdStr);
	var oldVal = targetSelect.val();
	var options = "<option></option>";
	fieldOptions.forEach(function(option) {
		options += '<option value="' + option.name + '"';
		if (oldVal != null && oldVal == option.name) {
			options += '" selected=""';
		}
		options += ">" + option.name + "</option>";
	});
	targetSelect.html(options);
}

function requestProjectData(projKey) {
	var restURL = baseUrl + "/rest/jemh/latest/api/config/data/project/" + projKey+'?mappingId='+AJS.$("input[name='projConfigId']").val()+'&atl_token='+AJS.$("input[name='atl_token']").val();
	AJS.$.get(restURL, function (data) {
		if (data != null)
		{
			updateFormSelect(data.issueTypes, "issueType");
			updateFormSelect(data.components, "component");
			updateFormSelect(data.versions, "affectsVersion");
			updateFormSelect(data.versions, "fixForVersion");
			updateFormSelect(data.securityLevels, "securityLevel");
			updateFormSelect(data.priorities, "jemh-priority");
			AJS.flag({type: 'success', title: 'Form updated', body: '<p>The form options have been updated for project ' + data.projectName + ' ('+data.projectKey+').</p>', close: 'auto'});
		}
	}, "json").fail(function (response) {
		AJS.flag({type: 'error', title: 'Form not updated', body: '<p>The form options could not be updated. Server responded with status code <b>'+response.status+'<b>.</p><p>See browser console for details.</p>', close: 'auto'});
	});
}

function htmlEncode(value) {
	return String(value).replace(/[&<>"'`=\/]/g, function (s) {
	    return entityMap[s];
	  });
}

AJS.$(document).ready(function(){

	console.log("jemhui.js loading");
	var resourceUrl = baseUrl+'/rest/jemh/latest/banner/jaxbtest';
	AJS.$.getJSON(resourceUrl, {atl_token: atl_token()}, function (results) {
	}).done(function() {
		console.log("JEMH Banners: Initial banner JAXB XML export test was successful");
	}).fail(function() {
		console.log("JEMH Banners: Initial banner JAXB XML export test failed");
		AJS.$("#jemh-header-banner").append('<header id="header" role="banner" class="jemh-licensing-banner"> <div class="aui-banner aui-banner-error" role="banner" aria-hidden="false"><strong>XML Export Error</strong> JAXB is not able to marshall beans, this may be due to your JVM arguments please see: <a href="https://thepluginpeople.atlassian.net/wiki/spaces/KB/pages/3708944436/XML+Export+Error">XML Export Error</a></header>');
	});


	AJS.$(function(){var toggle=new JIRA.ToggleBlock({blockSelector:".toggle-wrap",triggerSelector:".mod-header h3"})});

	AJS.$('.jemh-minimise').click(function(e) {
		AJS.$('.toggle-wrap').not('.collapsed').addClass('collapsed');
		e.preventDefault();
	});

	AJS.$('.jemh-expand').click(function(e) {
		AJS.$('.toggle-wrap.collapsed').removeClass('collapsed');
		e.preventDefault();
	});

	AJS.$('.jemh-uncheckall').click(function(e) {
		AJS.$('.jemh-issue-event-select').each(function() {
			AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",false);
			AJS.$(this).find('option:contains("DEFAULT (Jira)")').removeAttr("selected");

			AJS.$(this).val('');
		});
		e.preventDefault();
	});

	AJS.$('.jemh-checkall').click(function(e) {
		AJS.$('.jemh-issue-event-select').each(function() {
			var themeId = AJS.$('#jiraDefaultTheme').val();
			if(themeId === "0" || themeId === "-1")
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",true);
			}
			else if (themeId === "-2")
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (JSM)")').attr("selected",true);
			}
			else
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",true);
			}		});
		e.preventDefault();
	});

	<!-- show preproc task edit dialog -->
	AJS.$(".jemh-preproctask-edit-link").click(function(event) {

		event.preventDefault();

		AJS.$.get(AJS.$(this).attr('href')+'&backUrl='+encodeURI(document.location), function(response) {
			var dialog = new AJS.Dialog({
				width: 1024,
				height: 800,
				id: "Pre Proc Task Properties",
				closeOnOutsideClick: false
			});

			dialog.addHeader("Pre Processing Task Properties");
			dialog.addPanel('Properties', response, 'stuff');
			dialog.addButton('Submit', function (dialog) { return true; }, 'jemh-preproctask-submit-button');
			dialog.addButton('Close', function (dialog) {dialog.hide();}, 'jemh-preproctask-cancel-button');
			dialog.show();

			AJS.$(".jemh-preproctask-submit-button").click(function() {
				AJS.$("#preProcTaskPropertiesForm").submit();
			});
		});

		return true;
	});

	<!-- show status notification config edit dialog -->
	AJS.$(".edit-status-notification-config-link").click(function(event) {

		event.preventDefault();

		AJS.$.get(AJS.$(this).attr('href')+'&backUrl='+encodeURI(document.location), function(response) {
			var dialog = new AJS.Dialog({
				width: 800,
				height: 800,
				id: "Status Notification Configuration",
				closeOnOutsideClick: false
			});

			dialog.addHeader("Status Notification Configuration");
			dialog.addPanel('Configuration', response, 'stuff');
			dialog.addButton('Submit', function (dialog) { return true; }, 'status-notification-config-submit-button');
			dialog.addButton('Close', function (dialog) {dialog.hide();}, 'status-notification-config-cancel-button');
			dialog.show();

			AJS.$(".status-notification-config-submit-button").click(function() {
				AJS.$("#statusNotificationConfigForm").submit();
			});
		});

		return true;
	});

	var isNewDefMapping = false;
	var isConfirmedDefMapping = false;
	AJS.$("#isDefaultMapping").change(function() {
		isNewDefMapping = this.checked;
	});

	AJS.$("#jemhProjectConfigForm").submit(function(e) {
		if (isNewDefMapping && !isConfirmedDefMapping) {
			e.preventDefault();
			AJS.dialog2("#jemh-defaultConfirm-dialog").show();
		}
	});

	AJS.$("#jemh-confDefMap-btn").click(function() {
		isConfirmedDefMapping = true;
		AJS.dialog2("#jemh-defaultConfirm-dialog").hide();
		AJS.$("#jemhProjectConfigForm").submit();
	});

	AJS.$("#jemh-cnclDefMap-btn").click(function() {
		isConfirmedDefMapping = false;
		AJS.dialog2("#jemh-defaultConfirm-dialog").hide();
    });

	// prompt for pm delete
	AJS.$(".jemh-pm-delete-link").click(function(event) {

		event.preventDefault();

		if (AJS.$(this).attr('style')=='cursor:not-allowed')
		{
			console.log('ignore delete on default mapping');
			return;
		}

		var linkUrl = AJS.$(this).attr('href');
		var closestTr = AJS.$(this).closest('tr');
		console.log('link url: '+linkUrl);

		var dialog = new AJS.Dialog({
		    width: 400,
		    height: 200,
		    id: "jemh-delete-pm",
		    closeOnOutsideClick: true
		});

		dialog.addHeader("Delete Project Mapping?");
		dialog.addPanel("Panel 1", "<p>Are you sure?</p>", "panel-body");
		dialog.addButton("Delete Mapping", function (dialog) {
			AJS.$.get(linkUrl, function() {
				console.log('deleted');
				AJS.$(closestTr).remove();
				location.reload();
			});
		    return;
		});
		dialog.addLink("Cancel", function (dialog) {
		    event.preventDefault();
		    dialog.hide();
		}, "#");

	    dialog.gotoPage(0);
	    dialog.gotoPanel(0);
		dialog.show();
	});

	AJS.$("#jemh-confirmChange-btn").click(function(e) {
		var projKey = AJS.$('.jemh-project-picker').select2('val');
		requestProjectData(projKey);
		e.preventDefault();
		AJS.dialog2("#jemh-confChange-dialog").hide();
	});

	AJS.$("#jemh-cancelChange-btn").click(function(e) {
		e.preventDefault();
		AJS.dialog2("#jemh-confChange-dialog").hide();
	});

	AJS.$(".jemh-select-text, .jemh-multiselect-text, .jemh-select-multiuser, .jemh-select-datetime, .jemh-select-group").auiSelect2({
		allowClear: true
	});

	AJS.$(document).ready( function(){
		var regexEls = AJS.$('.regex'),
		len = regexEls.length,
		el, text, i;

		for (i = 0; i < len; i++) {
			el = regexEls[i];
			text = el.textContent || el.innerText;

			// this is where the magic happens
			if (text)
			{
				try {
					el.innerHTML = highlightJsReSyntax(text);
				} catch(err) {
				}
			}
		}
	});

    //JSD Filter
	AJS.$('#jemh-filter-jsd').click(function() {
		AJS.$('.jemh-filter-templates-jira').hide();
		AJS.$('.jemh-filter-templates').hide();
		AJS.$('.jemh-filter-templates-jsd').show();
		AJS.$("#jiraDefaultTheme").val(-2)
	});

    AJS.$('#jemh-filter-jira').click(function() {
		AJS.$('.jemh-filter-templates-jsd').hide();
		AJS.$('.jemh-filter-templates').hide();
		AJS.$('.jemh-filter-templates-jira').show();
		AJS.$("#jiraDefaultTheme").val(0)
	});

    AJS.$('#jemh-filter-none').click(function() {
		AJS.$('.jemh-filter-templates-jira').show();
		AJS.$('.jemh-filter-templates').show();
		AJS.$('.jemh-filter-templates-jsd').show();
		AJS.$("#jiraDefaultTheme").val(-1)
	});

    //Jira Filter
	AJS.$('#jemh-customer-filter-jsd').click(function() {
		AJS.$('.jemh-filter-customer-templates-jira').hide();
		AJS.$('.jemh-filter-customer-templates').hide();
		AJS.$('.jemh-filter-customer-templates-jsd').show();
		AJS.$("#jsdDefaultTheme").val(-2)
	});

	AJS.$('#jemh-customer-filter-jira').click(function() {
		AJS.$('.jemh-filter-customer-templates-jsd').hide();
		AJS.$('.jemh-filter-customer-templates').hide();
		AJS.$('.jemh-filter-customer-templates-jira').show();
		AJS.$("#jsdDefaultTheme").val(0)
	});

	AJS.$('#jemh-customer-filter-none').click(function() {
		AJS.$('.jemh-filter-customer-templates-jira').show();
		AJS.$('.jemh-filter-customer-templates').show();
		AJS.$('.jemh-filter-customer-templates-jsd').show();
		AJS.$("#jsdDefaultTheme").val(-1)
	});

	AJS.$('#jemh-nonjira-filter-jsd').click(function() {
		AJS.$('.jemh-nonjira-filter-templates-jira').hide();
		AJS.$('.jemh-nonjira-filter-templates').hide();
		AJS.$('.jemh-nonjira-filter-templates-jsd').show();
		AJS.$("#nonJiraDefaultTheme").val(-2)
	});

	AJS.$('#jemh-nonjira-filter-jira').click(function()
	{
		AJS.$('.jemh-nonjira-filter-templates-jsd').hide();
		AJS.$('.jemh-nonjira-filter-templates').hide();
		AJS.$('.jemh-nonjira-filter-templates-jira').show();
		AJS.$("#nonJiraDefaultTheme").val(0)
	});

	AJS.$('#jemh-nonjira-filter-none').click(function() {
		AJS.$('.jemh-nonjira-filter-templates-jira').show();
		AJS.$('.jemh-nonjira-filter-templates').show();
		AJS.$('.jemh-nonjira-filter-templates-jsd').show();
		AJS.$("#nonJiraDefaultTheme").val(-1)
	});

	//JSD select Defaults
	AJS.$('.jemh-customer-uncheckall').click(function(e) {
		AJS.$('.jemh-issue-event-select-jsd').each(function() {
			AJS.$(this).find('option:contains("DEFAULT (JSD)")').attr("selected",false);
			AJS.$(this).find('option:contains("DEFAULT (JSD)")').removeAttr("selected");
			AJS.$(this).val('');
		});
		e.preventDefault();
	});

	AJS.$('.jemh-customer-checkall').click(function(e) {
		AJS.$('.jemh-issue-event-select-jsd').each(function() {
			var themeId = AJS.$('#jsdDefaultTheme').val();
			if(themeId === "0" || themeId === "-1")
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",true);
			}
			else if (themeId === "-2")
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (JSM)")').attr("selected",true);
			}
			else
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",true);
			}
		});
		e.preventDefault();
	});

	AJS.$('.jemh-nonjira-uncheckall').click(function(e) {
		AJS.$('.jemh-issue-event-select-nonjira').each(function() {
			AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",false);
			AJS.$(this).find('option:contains("DEFAULT (Jira)")').removeAttr("selected");
			AJS.$(this).find('option:contains("DEFAULT (JSD)")').attr("selected",false);
			AJS.$(this).find('option:contains("DEFAULT (JSD)")').removeAttr("selected");
			AJS.$(this).val('');
		});
		e.preventDefault();
	});

	AJS.$('.jemh-nonjira-checkall').click(function(e) {
		AJS.$('.jemh-issue-event-select-nonjira').each(function() {
			var themeId = AJS.$('#nonJiraDefaultTheme').val();
			if(themeId === "0" || themeId === "-1")
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",true);
			}
			else if (themeId === "-2")
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (JSM)")').attr("selected",true);
			}
			else
			{
				AJS.$(this).removeAttr('selected');
				AJS.$(this).find('option:contains("DEFAULT (Jira)")').attr("selected",true);
			}
		});
		e.preventDefault();
	});
	
	// hide pre proc tasks if pre-processing is not enabled
	function updatePreProcTaskSelectVisibility() {
		if (AJS.$("#useReprocessedMessage").prop("checked")) {
			AJS.$("#preProcTaskSelectDiv").show(500);
		} else {
			AJS.$("#preProcTaskSelectDiv").hide(500);
		}
	}


	
	AJS.$("#useReprocessedMessage").click(function() {
		updatePreProcTaskSelectVisibility();
	});
	
	updatePreProcTaskSelectVisibility();
});
