AJS.$(document).ready(function(){	
	console.log('macroedit.js loading');
	
	var macroEditor;
	var previewEditor;
	
	if (AJS.$("#macros-edit-wrapper").length>0) {
		macroEditor = buildAceEditor('jemhUserMacrosEditForm', 'macro-text-editor', 'macro-text-statusBar', 'text', 'velocity');
	}

	if (AJS.$("#macros-velocity-scratchpad-wrapper").length>0) {
		previewEditor = buildAceEditor('jemhUserMacrosEditForm', 'macros-velocity-scratchpad-editor', 'macros-velocity-scratchpad-statusBar', 'contentToRender', 'velocity');
		
		AJS.$("#macroedit-preview_link").click(function(e) {
			e.preventDefault();
			showPreview(previewEditor, 'macros-velocity-scratchpad-wrapper', 'macros-velocity-scratchpad-results', 'velocity');
		});
	}
	
	AJS.$(function(){var toggle=new JIRA.ToggleBlock({blockSelector:".toggle-wrap",triggerSelector:".mod-header h3"})});
	
	function showPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs) {
	  	console.log("Showing macro preview");
	  	AJS.$(editWrapperDivId).hide();
	  	AJS.$(previewWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("Rendering, please wait...");
	  	//AJAX POST of content to render

		AJS.$("#scratchpadContent").val(editor.getSession().getValue());
	  	AJS.$("#macroContentToRender").val(macroEditor.getSession().getValue());

		var postData=AJS.$('#jemhMacroEditPreviewDataForm').serialize();
	  	console.log('posting template for rendering. post data: '+postData);

		var formUrl = AJS.$('#jemhMacroEditPreviewDataForm').attr('action');																										
	  	console.log('post url: '+formUrl);
	  	
	  	AJS.$("#"+previewWrapperDivId).html('<i>Loading</i>');
	  	
		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,			
			dataType:"text",
			data:postData,
			timeout:60000
		}); //post
				
		console.log("waiting for completion");
												  	
	  	jqXHR.done(function(data, textStatus, errorThrown) {
	  		console.log("post returned with: "+data);
	  		if (showTypeAs=='text')
	  		{
	  			<!-- http://stackoverflow.com/questions/1219860/html-encoding-in-javascript-jquery -->
	  			data=('<pre>'+AJS.$("<div/>").text(data).html()+'</pre>');
	  		}
	  		if (AJS.$("#"+previewWrapperDivId))
	  		{
	  			console.log('preview wrapper found, updating');
	  			var encodedData=AJS.$('<div/>').text(data).html();
	  			AJS.$("#"+previewWrapperDivId).html('<pre>'+encodedData+'</pre>');
	  		}
	  		else
	  		{
	  			console.log('preview wrapper not found');
	  		}
	  			
	  	}).fail(function(data, textStatus, errorMessage) {
			console.log("RUN fail: textStatus="+textStatus+", errorMessage: "+errorMessage);
			AJS.messages.generic(previewWrapperDivId, {
			   title:"Custom Context Demo",
			   body: '<p>Run failed, status: '+textStatus+', error: '+errorMessage+'</p>'
			});			
	  	});
	  		  	
	}
});