AJS.$(document).ready( function(){
	console.log("JEMH script preproc task script loading editor components");
	let baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	let aceLoaded=false;
	let editor;
    /* http://stackoverflow.com/questions/6298169/how-to-create-a-map-object-in-a-javascript */
    	
    function loadAce(setupUIfn) {
		console.log( "loading custom ace-editor.js script");
		AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ace.js" )
		  .done(function( script, textStatus ) {
		     console.log( "ace.js was downloaded: "+textStatus+", loading CSS" );
		     
		     /* https://groups.google.com/forum/#!topic/ace-discuss/2tXbbF9MCMY */
		     ace.config.set("basePath", baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace");
		     
		     AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ext-spellcheck.js" )
		     .done(function( script, textStatus ) {
		        console.log( "ext-spellcheck.js script was downloaded: "+textStatus);
		     })
		     .fail(function( jqxhr, settings, exception ) {
		       console.log( "custom ext-spellcheck.js script could not be downloaded" );
		     });
		     
			 AJS.$('<link>')
			  .appendTo('head')
			  .attr({type : 'text/css', rel : 'stylesheet'})
			  .attr('href', baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace-editor.css");

			 console.log( "CSS loaded, now adhoc custom script" );
			 AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace-editor.js" )
			  .done(function( script, textStatus ) {
			     console.log( "custom ace-editor.js script was downloaded: "+textStatus+", setting up adhoc UI");
			     setupUIfn();
			     aceLoaded=true;
			  })
			  .fail(function( jqxhr, settings, exception ) {
			    console.log( "custom ace-editor.js script could not be downloaded" );
			 });
		  })
		  .fail(function( jqxhr, settings, exception ) {
		    console.log( "ace.js could not be downloaded" );
		});
	}

    function setupPreProcScriptEditor() {
		let formName='preProcTaskPropertiesForm';
		for (let i = 0; i < preprocTaskEditors.length; i++) {
			console.log("initialising field editor: "+preprocTaskEditors[i]);
			let editorName='field'+preprocTaskEditors[i]+'-editor';
			let statusBarName='field'+preprocTaskEditors[i]+'-statusBar';
			let textareaName='field'+preprocTaskEditors[i];
			let contentType='velocity';
			editor=buildAceEditor(formName, editorName, statusBarName, textareaName, contentType);
			var currentVal=AJS.$("#"+textareaName).val();
			//console.log('current value: '+currentVal);
			editor.getSession().setValue(currentVal);
			//console.log('built editor for '+textareaName);
		}

		//Set value of hidden header script
		AJS.$("#jemh-hidden-header-script").val(AJS.$("#field2").val());

		//Stores value of header script into hidden input to be used when rendering.
		AJS.$(".jemh-header-editor").keyup(function(){
			let editor = ace.edit("field2-editor");
			let headerValue = editor.getValue();
			AJS.$("#jemh-hidden-header-script").val(headerValue);
		});

		AJS.$(document).keyup(function(e){
			if(e.keyCode === 27)
			{
				console.log('escape: shutting down editors');
				shutdown();
			}
		});

		AJS.$(".jemh-preproctask-cancel-button").on('click', function () {
			shutdown();
		});
	}

    if (aceLoaded===false) {
  		loadAce(function setupUIfn(){
	  		setupPreProcScriptEditor();
  		});
	} else {
		console.log('ACE already loaded on this page for pre-proc tasks');
		setupPreProcScriptEditor();
	}

	//destroy
	function shutdown()
	{
		AJS.$("#Pre Proc Task Properties").remove();
		try
		{
			for (let i = 0; i < preprocTaskEditors.length; i++) {
				console.log("Shutting down editor: " + preprocTaskEditors[i]);
				let editorName='field'+preprocTaskEditors[i]+'-editor';
				if (editorName != null) {
					let editorToKill = ace.edit(editorName);
					if (editorToKill != null) {
						editorToKill.destroy();
						editorToKill.container.remove();
					}
				}
			}
		}
		catch (e)
		{
			console.error('unable to destroy ace-editor: '+e);
		}

		//clear content
		if (aceLoaded)
		{
			try
			{
				if (editor != null) {
					editor.destroy();
				}
				AJS.$('.jemh-editor').remove();
				AJS.$('#preProcTaskPropertiesForm').remove();
			}
			catch (e)
			{
				console.error('unable to destroy ace-editor: '+e);
			}
			finally
			{
				aceLoaded=false;
			}
		}
	}
});