AJS.$(document).ready(function() {
    function hookGroupOutcomeControl() {
    AJS.$('#groupDefault').on('change', showHideGroupOutcomeControlCheckbox);
}
function showHideGroupOutcomeControlCheckbox() {
    const isDefaultProfileSelected = AJS.$('#groupDefault').is(':checked');

    if (!isDefaultProfileSelected) {
        AJS.$('#groupOutcomeControl').parent().hide(500);
        AJS.$('#processOutcomesToIgnore').parent().show(500);
    } else {
        AJS.$('#groupOutcomeControl').parent().show(500);
        AJS.$('#processOutcomesToIgnore').parent().hide(500);
    }
}

// Shows the dialog when the "Show dialog" button is clicked
AJS.$('#import-dialog-open').on('click', function(e) {
    AJS.dialog2('#import-dialog').show();
    AJS.$('#import-dialog-submit').show();
    AJS.$('#jemhProfileImportForm').show();
    AJS.$('#import-dialog-hints').show();
    AJS.$('#import-result-content').hide();
    AJS.$('#import-process-content').hide();
    AJS.$('#import-progress-bar').hide();
});

// Submits the dialog
AJS.$('#import-dialog-submit').on('click', function (e) {
    e.preventDefault();
    var formData = new FormData();
    if (AJS.$('#uploadFile').prop('files').length > 0) {
        var file = AJS.$('#uploadFile').prop('files')[0];
        var createMissingProj = AJS.$('#createMissingProjects').prop('checked');
        var createMissingFields = AJS.$('#createMissingCustomFields').prop('checked');
        var fixUserRoles = AJS.$('#fixUserRoles').prop('checked');
        var fixIssueTypes = AJS.$('#fixIssueTypes').prop('checked');
        var atl_token = AJS.$('#atl_token').val();
        formData.append('xmlFile', file, file.name);

        var url = AJS.$('#postTaskFileUrl').val() + '?createMissingProjects=' + createMissingProj + '&createMissingCustomFields=' + createMissingFields + '&fixUserRoles=' + fixUserRoles + '&fixIssueTypes=' + fixIssueTypes + '&atl_token=' + atl_token;

        AJS.$.ajax({
            type: 'post',
            url: url,
            data: formData,
            contentType: false,
            processData: false,
            beforeSend: beforeUpload,
            success: processImportResults,
            error: processFailure,
            timeout: 1200000, //20 mins timeout
        });
    }
});

// Refreshes the page
AJS.$('#import-dialog-cancel').on('click', function (e) {
    AJS.dialog2('#import-dialog').hide();
    location.reload();
});

// Hides the dialog
AJS.$('#import-dialog-close').on('click', function (e) {
    AJS.dialog2('#import-dialog').hide();
});


// Hides the dialog
AJS.$('#feedBack-dialog-close').on('click', function (e) {
    AJS.dialog2('#feedBack-dialog').hide();
});

var startTime;
    function beforeUpload() {
    AJS.$('#import-dialog-submit').hide();
    AJS.$('#import-dialog-cancel').prop('disabled', true);
    AJS.$('#import-process-content').show();
    AJS.$('#import-progress-bar').show();
    AJS.$('#jemhProfileImportForm').hide();
    AJS.$('#import-dialog-hints').hide();
    AJS.$('#feedBack-dialog-message').text('Running...');
    AJS.$('#profile-import-spinner').spin('small', {speed: 2});
    startTime = new Date();
}

function processImportResults(data, textStatus, jqXHR) {
	AJS.$('#import-dialog').css('width','60%');
    AJS.$('#import-dialog-cancel').prop("disabled", false);
    AJS.$('#import-process-content').hide();
    AJS.$('#import-progress-bar').hide();
    AJS.$('#import-result-content').show();
    var endTime = new Date();
    var timeTaken = new Date();
    var minutesTaken = endTime.getMinutes() - startTime.getMinutes();
    var secondsTaken =  Math.abs(endTime.getSeconds() - startTime.getSeconds());
    var secondStr = (secondsTaken >= 9) ? secondsTaken.toString() : "0" + secondsTaken.toString();
    AJS.$('#result-dialog-title').css("font-weight", "bold");

    if(typeof data !== "undefined"){
        var errorStr = JSON.stringify(data.errorMessage);
        if(typeof errorStr === "undefined"){
            AJS.$('#import-result-content-text').prepend('<p class="aui-message aui-message-confirmation"><strong>Profile import successful. Time taken: ' + minutesTaken + 'm ' + secondStr +'s</strong></p>');
            for( resultVal in data){
                var results = data[resultVal];
                for(resultInt in results){
                    var result = results[resultInt];
                    var resultID = result.profileID;
                    var resultName = result.profileName;
                    var resultMessages = result.messages;
                    var projectMappingsNotExported = result.projectMappingsNotExported;
                    var projectMappingsNotImported = result.projectMappingsNotImported;

                    AJS.$('#result-dialog-list').append('<table class="aui"><thead><tr><th>Profile['+ resultID +'] ' + resultName + ' has been imported' + '</th></tr></thead><tbody>');

                    for(messageID in resultMessages){
                        AJS.$('#result-dialog-list').append('<tr><td>' + resultMessages[messageID] + '</td></tr>');
                    }
                    AJS.$('#result-dialog-list').append('</tbody></table>');

                    if (projectMappingsNotExported > 0)
                    {
                        AJS.$('#import-result-content-text').prepend('' +
                            '<div class="aui-message aui-message-info">' +
                                '<p class="title">' +
                                    '<strong>Info</strong>' +
                                '</p>' +
                                '<p>' + 'Some Project Mappings (' + projectMappingsNotExported + ') were not included in this Profiles XML file due to:' +
                                    '<ul>' +
                                        '<li>No valid associated Project</li>' +
                                        '<li>No Mapping Rules</li>' +
                                    '</ul>' +
                                '</p>' +
                            '</div>');
                    }

                    if (projectMappingsNotImported > 0)
                    {
                        AJS.$('#mappings-without-projects-not-imported-message').append('<table class="aui"><thead><tr><th>' + 'Some Project Mappings (' + projectMappingsNotImported + ') have not been imported from this Profiles XML file due to:' +
                            '<ul>' +
                                '<li>No Project Key</li>' +
                                '<li>No Mapping Rules</li>' +
                            '</ul>');
                    }
                    AJS.$('#result-dialog-list').append('</tbody></table>');
                }
            }
        }else{
            AJS.$('#import-result-content-text').prepend('<p class="aui-message aui-message-error"><strong>Profile import error, cause: ' + data.errorMessage +'</strong></p>');
            AJS.$('#import-result-content-text').append('<p>Unable to import profile due to application error. Please contact <a href="mailto:support@thepluginpeople.com">support@thepluginpeople.com</a> and attach your Profile XML and the technical info below.</p>');
            AJS.$('#result-dialog-list').append('<p style="font-size:9px">' + data.stackTrace + '</p>');
        }
    }else{
      AJS.$('#import-result-content-text').prepend('<p class="aui-message aui-message-error"><strong>Profile import error: No return</strong></p>');
      AJS.$('#import-result-content-text').append('<p>Unable to import profile due to application error. Please contact <a href="mailto:support@thepluginpeople.com">support@thepluginpeople.com</a> and attach your Profile XML</p>');
    }
}

function processFailure(jqXHR, textStatus, errorThrown){

    AJS.$('#import-dialog-cancel').prop("disabled", false);
    AJS.$('#import-process-content').hide();
    AJS.$('#import-progress-bar').hide();
    AJS.$('#import-result-content').show();

    //identifies a timeout
    if(textStatus =="timeout"){
        AJS.$('#import-result-content-text').prepend('<p class="aui-message aui-message-error"><strong>Profile import timeout</strong></p>');
        AJS.$('#import-result-content-text').append('<p>Profile failed to import due to a timeout. JEMH allows up to 20 minuets for upload. Restores of large profiles on a clean instance can create a lot of fields, taking a lot of time. Failures due to this can be worked around by repeated upload attempts. If problems persist see <a href="https://thepluginpeople.atlassian.net/l/c/SSCyZ1dv">our wiki</a>, or reach out to <a href="mailto:support@thepluginpeople.com">support@thepluginpeople.com</a>.</p>');
    }
    else{
        AJS.$('#import-result-content-text').prepend('<p class="aui-message aui-message-error"><strong>Profile import failed due to '+ errorThrown+'</strong></p>');
        AJS.$('#import-result-content-text').append('<p>Import failed due to network request failure of type ' + errorThrown +'.</p>');
    }
}
hookGroupOutcomeControl();
showHideGroupOutcomeControlCheckbox();
});