AJS.$(document).ready( function(){
	console.log("Static Resources script loading");
	
	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
	var atl_token = AJS.$('#atl_token').val();

	AJS.$(".jemh-staticresource-img").click(function(e) {
		console.log('click');
		e.preventDefault();
		var img=AJS.$(this)

		var title = img.attr('title');

		if (title === 'Click here to close image') {
			img.attr('title', 'click to preview');
			img.attr('rendered', true).attr('src', '');
		} else {
			var id = img.attr('data');
			var url = baseUrl + "/rest/jemh/latest/staticresource/encode/" + id + "?atl_token=" + atl_token;

			var jqXHR = AJS.$.ajax({
				type: "GET",
				dataType: "text",
				contentType: "text/plain; charset=utf-8",
				url: url,
				timeout: 15000
			});

			jqXHR.done(function (data, textStatus, errorMessage) {
				img.attr('src', data).attr('title', 'Click here to close image').attr('rendered', false);
			}).fail(function (data, textStatus, errorMessage) {
				console.error("Failed to get image preview: " + textStatus + ", status: " + jqXHR.status + ", response: " + jqXHR.responseText);
			});
		}
	});
	
	//setup select
	AJS.$("#filterByProject").auiSelect2();
	//submit on change
	AJS.$("#filterByProject").change(function(e) {
		AJS.$("#jemhStaticResourcesFilterForm").submit();
	});

	AJS.$(".import-dialog-close-button").click(function(e) {
		e.preventDefault();
		closeImportDialog(e);
	});

	AJS.$('#jemh-staticresource-import-all').on('click', function() {
		let importDialog = AJS.$('#jemh-staticresources-import-dialog');
		if (importDialog.attr('id') != null) {
			AJS.dialog2('#jemh-staticresources-import-dialog').show();
		}
	});

	AJS.$(document).keyup(function(e){
		if(e.keyCode === 27)
		{
			closeImportDialog(e);
		}
	});

	AJS.$("#createStaticResourceButton").on("click", function () {
		var value = AJS.$("#resourceUpload").val();

		if (value) {
			AJS.$("#submitCreateStaticResource").attr("disabled",false);
		} else {
			AJS.$("#submitCreateStaticResource").attr("disabled", true);
		}
	});


	AJS.$('#resourceUpload').change(function(e) {
		var value = AJS.$("#resourceUpload").val();
        if(value){
            AJS.$("#submitCreateStaticResource").attr("disabled", false);
        }else{
             AJS.$("#submitCreateStaticResource").attr("disabled", true);
         }
    });

	function closeImportDialog(e) {
		e.preventDefault();
		AJS.$('#uploadFile').val('');
		AJS.dialog2('#jemh-staticresources-import-dialog').hide();
	}

	function prepareOnEventActions() {
		AJS.$("#createStaticResourceButton").on("click", function () {
			AJS.dialog2("#createStaticResourcesDialog").show();
			console.log("Show dialog");
		});

		AJS.$("#cancelCreateStaticResource").on("click", function () {
			AJS.dialog2("#createStaticResourcesDialog").hide();
			console.log("Hide dialog");
		});
	}

	AJS.$("#submitCreateStaticResource").on("click", function (e) {
		e.preventDefault();
		var formData = new FormData();
		if (AJS.$('#resourceUpload').prop('files').length > 0) {
			var file = AJS.$('#resourceUpload').prop('files')[0];
			var imgWidth = AJS.$('#imgWidth').val();
			var imgHeight = AJS.$('#imgHeight').val();
			var fileDescription = AJS.$('#fileDescription').val();
			let atl_token = AJS.$('input[name="atl_token"]').val();
			let projectKey = AJS.$('#projectKey').val();

			formData.append('imageFile', file, file.name);

			var url = AJS.$('#postTaskFileUrl').val() + '?projectKey=' + projectKey + '&imgWidth=' + imgWidth + '&imgHeight=' + imgHeight + '&fileDescription=' + fileDescription + '&atl_token=' + atl_token;

			var jqXHR = AJS.$.ajax({
				type: 'post',
				url: url,
				data: formData,
				contentType: false,
				processData: false,
				timeout: 1200000, //20 mins timeout
			});

			jqXHR.done(function (data, textStatus, errorThrown) {
				// On success hide the dialog and then refresh the page to view the new PM
				AJS.dialog2("#createStaticResourcesDialog").hide();
				location.reload();

			}).fail(function (data, textStatus, errorMessage) {
				// Provide info if the Project Mapping couldn't be created
				window.alert("Error when creating Static Recourse!");
				AJS.dialog2("#createStaticResourcesDialog").hide();
			});
		}
	});

	prepareOnEventActions();
});

